//
//  HTML5 PivotViewer
//
//  Collection loader interface - used so that different types of data sources can be used
//
//  Original Code:
//    Copyright (C) 2011 LobsterPot Solutions - http://www.lobsterpot.com.au/
//    enquiries@lobsterpot.com.au
//
//  Enhancements:
//    Copyright (C) 2012-2013 OpenLink Software - http://www.openlinksw.com/
//
//  This software is licensed under the terms of the
//  GNU General Public License v2 (see COPYING)
//
///PivotViewer
var global={},PivotViewer=PivotViewer||{};PivotViewer.Version="0.9.178-8be0d74",PivotViewer.Models={},PivotViewer.Models.Loaders={},PivotViewer.Utils={},PivotViewer.Views={};var Debug=Debug||{};(function(a){var b={};a.publish=function(c,e){b[c]&&a.each(b[c],function(){this.apply(a,e||[])})},a.subscribe=function(a,c){return b[a]||(b[a]=[]),b[a].push(c),[a,c]},a.unsubscribe=function(c){var e=c[0];b[e]&&a.each(b[e],function(a){this==c[1]&&b[e].splice(a,1)})}})(jQuery),Debug.Log=function(a){window.console&&window.console.log&&typeof debug!="undefined"&&debug==1&&window.console.log(a)},window.requestAnimFrame=function(a){return window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||function(a){window.setTimeout(a,1e3/60)}}(),PivotViewer.Utils.EscapeMetaChars=function(a){return a.replace(/\|/gi,"\\|").replace(/\//gi,"\\/").replace(/'/gi,"\\'").replace(/,/gi,"\\,").replace(/:/gi,"\\:").replace(/\(/gi,"\\(").replace(/\)/gi,"\\)").replace(/\+/gi,"\\+").replace(/\+/gi,"\\-").replace(/\+/gi,"\\_").replace(/\+/gi,"\\%")},PivotViewer.Utils.EscapeItemId=function(a){return a.replace(/\s+/gi,"|").replace(/'/gi,"").replace(/\(/gi,"").replace(/\)/gi,"").replace(/\./gi,"")},PivotViewer.Utils.HtmlSpecialChars=function(a){return jQuery("<div />").text(a).html()},PivotViewer.Utils.Now=function(){return Date.now?Date.now():(new Date).getTime()},PivotViewer.Utils.Min=function(a){var b=1e6;for(var c=0,d=a.length;c<d;c++)b=b>a[c]?a[c]:b;return b},PivotViewer.Utils.Max=function(a){var b=-1e6;for(var c=0,d=a.length;c<d;c++)b=b<a[c]?a[c]:b;return b},PivotViewer.Utils.Histogram=function(a){if(!a instanceof Array)return null;var b=PivotViewer.Utils.Min(a),c=PivotViewer.Utils.Max(a),d=(Math.floor(Math.pow(2*a.length,1/3))+1)*2;d>10&&(d=10);var e=(c+1-(b-1))/d,f=[];for(var g=0;g<d;g++){var h=b+g*e,i=b+(g+1)*e;f.push([]);for(var j=0,k=a.length;j<k;j++)h<=a[j]&&i>a[j]&&f[g].push(a[j])}return{Histogram:f,Min:b,Max:c,BinCount:d}},function(){var a=!1,b=/xyz/.test(function(){xyz})?/\b_super\b/:/.*/;Object.subClass=function(c){function g(){!a&&this.init&&this.init.apply(this,arguments)}var d=this.prototype;a=!0;var e=new this;a=!1;for(var f in c)e[f]=typeof c[f]=="function"&&typeof d[f]=="function"&&b.test(c[f])?function(a,b){return function(){var c=this._super;this._super=d[a];var e=b.apply(this,arguments);return this._super=c,e}}(f,c[f]):c[f];return g.prototype=e,g.constructor=g,g.subClass=arguments.callee,g}}(),PivotViewer.Models.Collection=Object.subClass({init:function(){var a="http://schemas.microsoft.com/collection/metadata/2009",b="http://schemas.microsoft.com/livelabs/pivot/collection/2009";this.CollectionName="",this.BrandImage="",this.FacetCategories=[],this.Items=[],this.CXMLBase="",this.ImageBase="",this.CopyrightName="",this.CopyrightHref="",this.MaxRelatedLinks=0},GetItemById:function(a){for(var b=0;b<this.Items.length;b++)if(this.Items[b].Id==a)return this.Items[b];return null},GetFacetCategoryByName:function(a){for(var b=0;b<this.FacetCategories.length;b++)if(this.FacetCategories[b].Name==a)return this.FacetCategories[b];return null}}),PivotViewer.Models.FacetCategory=Object.subClass({init:function(a,b,c,d,e,f,g){this.Name=a,this.Format=b,this.Type=c!=null&&c!=undefined?c:PivotViewer.Models.FacetType.String,this.IsFilterVisible=d!=null&&d!=undefined?d:!0,this.IsMetaDataVisible=e!=null&&e!=undefined?e:!0,this.IsWordWheelVisible=f!=null&&f!=undefined?f:!0,this.CustomSort}}),PivotViewer.Models.FacetCategorySort=Object.subClass({init:function(a){this.Name=a,this.SortValues=[]}}),PivotViewer.Models.Item=Object.subClass({init:function(a,b,c,d){this.Img=parseInt(a),this.Id=b,this.Href=c,this.Name=d,this.Description,this.Facets=[],this.Links=[]}}),PivotViewer.Models.ItemLink=Object.subClass({init:function(a,b){this.Name=a,this.Href=b}}),PivotViewer.Models.Facet=Object.subClass({init:function(a){this.Name=a,this.FacetValues=[]},AddFacetValue:function(a){this.FacetValues.push(a)}}),PivotViewer.Models.FacetValue=Object.subClass({init:function(a){this.Value=a,this.Href=""}}),PivotViewer.Models.FacetType={String:"String",LongString:"LongString",Number:"Number",DateTime:"DateTime",Link:"Link"},PivotViewer.Models.Loaders.ICollectionLoader=Object.subClass({init:function(){},LoadCollection:function(a){if(!a instanceof PivotViewer.Models.Collection)throw"collection not an instance of PivotViewer.Models.Collection."}}),PivotViewer.Models.Loaders.CXMLLoader=PivotViewer.Models.Loaders.ICollectionLoader.subClass({init:function(a,b){this.CXMLUriNoProxy=a,b?this.CXMLUri=b+a:this.CXMLUri=a},LoadCollection:function(a){var a=a;this._super(a),a.CXMLBaseNoProxy=this.CXMLUriNoProxy,a.CXMLBase=this.CXMLUri,$.ajax({type:"GET",url:this.CXMLUri,dataType:"xml",success:function(b){Debug.Log("CXML loaded");var c=$(b).find("Collection")[0],d=0,e="P";if(c==undefined){$(".pv-loading").remove();var f="";f+="Error parsing CXML Collection<br>",f+="<br>Pivot Viewer cannot continue until this problem is resolved<br>",$(".pv-wrapper").append('<div id="pv-parse-error" class="pv-modal-dialog"><div><a href="#pv-modal-dialog-close" title="Close" class="pv-modal-dialog-close">X</a><h2>HTML5 PivotViewer</h2><p>'+f+"</p></div></div>");var g=setTimeout(function(){window.open("#pv-parse-error","_self")},1e3);throw"Error parsing CXML Collection"}for(var h=0;h<c.attributes.length;h++)if(c.attributes[h].value=="http://schemas.microsoft.com/livelabs/pivot/collection/2009"){e=c.attributes[h].localName!=undefined?c.attributes[h].localName:c.attributes[h].baseName;break}a.CollectionName=$(c).attr("Name"),a.BrandImage=$(c).attr(e+":BrandImage")!=undefined?$(c).attr(e+":BrandImage"):"";var i=$(b).find("FacetCategory");for(var h=0;h<i.length;h++){var j=$(i[h]),k=new PivotViewer.Models.FacetCategory(j.attr("Name"),j.attr("Format"),j.attr("Type"),j.attr(e+":IsFilterVisible")!=undefined?j.attr(e+":IsFilterVisible").toLowerCase()=="true"?!0:!1:!0,j.attr(e+":IsMetaDataVisible")!=undefined?j.attr(e+":IsMetaDataVisible").toLowerCase()=="true"?!0:!1:!0,j.attr(e+":IsWordWheelVisible")!=undefined?j.attr(e+":IsWordWheelVisible").toLowerCase()=="true"?!0:!1:!0),l=j.find(e+"\\:SortOrder"),m=l.find(e+"\\:SortValue");l.length==0&&(l=j.find("SortOrder"),m=l.find("SortValue"));if(l.length==1){var n=new PivotViewer.Models.FacetCategorySort(l.attr("Name"));for(var o=0;o<m.length;o++)n.SortValues.push($(m[o]).attr("Value"));k.CustomSort=n}a.FacetCategories.push(k)}var p=$(b).find("Items");if(p.length==1){a.ImageBase=$(p[0]).attr("ImgBase");var q=$(p[0]).find("Item");if(q.length==0){$(".pv-loading").remove();var f="";f+="There are no items in the CXML Collection<br><br>",$(".pv-wrapper").append('<div id="pv-empty-collection-error" class="pv-modal-dialog"><div><a href="#pv-modal-dialog-close" title="Close" class="pv-modal-dialog-close">X</a><h2>HTML5 PivotViewer</h2><p>'+f+"</p></div></div>");var g=setTimeout(function(){window.open("#pv-empty-collection-error","_self")},1e3)}else for(var h=0;h<q.length;h++){var r=new PivotViewer.Models.Item($(q[h]).attr("Img").replace("#",""),$(q[h]).attr("Id"),$(q[h]).attr("Href"),$(q[h]).attr("Name")),s=$(q[h]).find("Description");s.length==1&&s[0].childNodes.length&&(r.Description=PivotViewer.Utils.HtmlSpecialChars(s[0].childNodes[0].nodeValue));var t=$(q[h]).find("Facet");for(var o=0;o<t.length;o++){var u=new PivotViewer.Models.Facet($(t[o]).attr("Name")),v=$(t[o]).children();for(var w=0;w<v.length;w++)if(v[w].nodeType==1){var y=$.trim($(v[w]).attr("Value"));if(y==null||y=="")if(v[w].nodeName=="Link")if($(v[w]).attr("Href")==""||$(v[w]).attr("Href")==null){var z=new PivotViewer.Models.FacetValue(PivotViewer.Utils.HtmlSpecialChars("(empty Link)"));u.AddFacetValue(z)}else if($(v[w]).attr("Name")==""||$(v[w]).attr("Name")==null){var z=new PivotViewer.Models.FacetValue("(unnamed Link)");z.Href=$(v[w]).attr("Href"),u.AddFacetValue(z)}else{var z=new PivotViewer.Models.FacetValue($(v[w]).attr("Name"));z.Href=$(v[w]).attr("Href"),u.AddFacetValue(z)}else{var z=new PivotViewer.Models.FacetValue(PivotViewer.Utils.HtmlSpecialChars("(empty "+v[w].nodeName+")"));u.AddFacetValue(z)}else if(v[w].nodeName=="Number"){var z=new PivotViewer.Models.FacetValue(parseFloat(y));u.AddFacetValue(z)}else{var z=new PivotViewer.Models.FacetValue(PivotViewer.Utils.HtmlSpecialChars(y));u.AddFacetValue(z)}}r.Facets.push(u)}var A=$(q[h]).find("Extension");if(A.length==1){var B=$(A[0]).find("d1p1\\:Related, Related");if(B.length==1){var C=$(B[0]).find("d1p1\\:Link, Link");for(var D=0;D<C.length;D++){var E=$(C[D]).attr("Name"),F=$(C[D]).attr("Href");if(F.indexOf(".cxml")==-1&&F.indexOf("pivot.vsp")>=0){var G=$.url(this.url);F=G.attr("protocol")+"://"+G.attr("authority")+G.attr("directory")+F}var H=new PivotViewer.Models.ItemLink(E,F);r.Links.push(H)}C.length>d&&(d=C.length)}}a.Items.push(r)}}a.MaxRelatedLinks=d;var I=$(b).find("Extension");if(I.length>1)for(x=0;x<I.length;x++){var J=$(I[x]).find("d1p1\\:Copyright, Copyright");if(J.length>0){a.CopyrightName=$(J[0]).attr("Name"),a.CopyrightHref=$(J[0]).attr("Href");break}}$.publish("/PivotViewer/Models/Collection/Loaded",null)},error:function(a,b,c){$(".pv-loading").remove();var d="";d+="Error loading CXML Collection<br><br>",d=d+"URL        : "+this.url+"<br>",d=d+"Status : "+a.status+" "+c+"<br>",d=d+"Details    : "+a.responseText+"<br>",d+="<br>Pivot Viewer cannot continue until this problem is resolved<br>",$(".pv-wrapper").append('<div id="pv-loading-error" class="pv-modal-dialog"><div><a href="#pv-modal-dialog-close" title="Close" class="pv-modal-dialog-close">X</a><h2>HTML5 PivotViewer</h2><p>'+d+"</p></div></div>");var e=setTimeout(function(){window.open("#pv-loading-error","_self")},1e3)}})}}),PivotViewer.Views.IPivotViewerView=Object.subClass({init:function(){this.isActive=!1,this.init=!0,this.selected="",this.tiles=[]},Setup:function(a,b,c,d,e){},Filter:function(a,b,c){},GetUI:function(){return""},GetButtonImage:function(){return""},GetButtonImageSelected:function(){return""},GetViewName:function(){return""},Activate:function(){this.isActive=!0},Deactivate:function(){this.isActive=!1}}),PivotViewer.Views.TileBasedView=PivotViewer.Views.IPivotViewerView.subClass({OffsetTiles:function(a,b){for(var c=0;c<this.tiles.length;c++){var d=$.inArray(this.tiles[c].facetItem.Id,this.currentFilter);d>=0&&(this.tiles[c]._locations[0].destinationx+=a,this.tiles[c]._locations[0].destinationy+=b)}},SetInitialTiles:function(a,b,c){var d=b/2,e=c/2;for(var f=0;f<a.length;f++)a[f]._locations[0].x=d,a[f]._locations[0].y=e,a[f].velocityx=0,a[f].velocityy=0,a[f]._locations[0].startx=d,a[f]._locations[0].starty=e,a[f]._locations[0].destinationx=0,a[f]._locations[0].destinationy=0,a[f].width=1,a[f].height=1},GetRowsAndColumns:function(a,b,c,d){var e=.7,f=c*(d-Math.pow(e,2)),g=(b+a*c)*e,h=-1*b*a,i=(-1*g+Math.sqrt(Math.pow(g,2)-4*f*h))/(2*f),j=Math.floor(i*c),k=Math.ceil(b/j),l=Math.floor(a/i),m=a-l*i;return{Rows:k,Columns:l,TileMaxWidth:i,TileHeight:j,PaddingX:m}},SetOuterTileDestination:function(a,b,c){var d=c._locations[0].x-a/2,e=c._locations[0].y-b/2,f=e/d,g=Math.atan2(e,d);c._locations[0].destinationx=a*Math.cos(g)+a/2,c._locations[0].destinationy=b*Math.sin(g)+b/2},SortBy:function(a,b,c,d){var e=function(b,d){if(c)for(var e=b.facetItem.Facets.length-1;e>-1;e-=1)if(b.facetItem.Facets[e].Name==a&&b.facetItem.Facets[e].FacetValues.length>0){if($.isNumeric(b.facetItem.Facets[e].FacetValues[0].Value))return c(b.facetItem.Facets[e].FacetValues[0].Value);for(var f=0;f<b.facetItem.Facets[e].FacetValues.length;f++)if(d.length>0)for(var g=0;g<d.length;g++)if(d[g].facet==a)for(var h=0;h<d[g].facetValue.length;h++)if(b.facetItem.Facets[e].FacetValues[f].Value==d[g].facetValue[h])return c(b.facetItem.Facets[e].FacetValues[f].Value);return c(b.facetItem.Facets[e].FacetValues[0].Value)}return null};return function(a,c){var f=e(a,d),g=e(c,d);return(f<g?-1:f>g?1:0)*[1,-1][+!!b]}}}),PivotViewer.Views.DataView=PivotViewer.Views.IPivotViewerView.subClass({init:function(){this._super()},Setup:function(a,b,c,d,e){},Filter:function(a,b,c){},GetUI:function(){return""},GetButtonImage:function(){return""},GetButtonImageSelected:function(){return""},GetViewName:function(){return"Grid View"}}),PivotViewer.Views.GraphView=PivotViewer.Views.TileBasedView.subClass({init:function(){this._super();var a=this;this.buckets=[],this.Scale=1,this.canvasHeightUIAdjusted=0,this.titleSpace=62,this.dontZoom=!1,$.subscribe("/PivotViewer/Views/Canvas/Click",function(b){if(!a.isActive)return;var c=null,d=null,e=null;for(var f=0;f<a.tiles.length;f++){var g=a.tiles[f].Contains(b.x,b.y);g>=0?(d=a.tiles[f],c=a.tiles[f].facetItem.Id,e=g):a.tiles[f].Selected(!1)}a.handleSelection(c,d,b.x,e)}),$.subscribe("/PivotViewer/Views/Canvas/Hover",function(b){if(!a.isActive)return;$(".pv-viewarea-graphview-overlay-bucket").removeClass("graphview-bucket-hover");var c=Math.floor((b.x-a.offsetX)/a.columnWidth),d=$("#pv-viewarea-graphview-overlay-bucket-"+c);d.addClass("graphview-bucket-hover");for(var e=0;e<a.tiles.length;e++){var f=a.tiles[e].Contains(b.x,b.y);f>=0?(a.tiles[e].Selected(!0),a.tiles[e].selectedLoc=f):a.tiles[e].Selected(!1)}}),$.subscribe("/PivotViewer/Views/Canvas/Zoom",function(b){if(!a.isActive)return;if(a.dontZoom){a.dontZoom=!1;return}var c=a.Scale,d=a.currentWidth,e=a.currentHeight,f=b.scale!=undefined?0:1e3;b.scale!=undefined?b.scale>=1?a.Scale+=b.scale-1:(a.Scale-=b.scale,a.Scale=a.Scale<1?1:a.Scale):b.delta!=undefined&&(a.Scale=b.delta==0?1:a.Scale+b.delta-1),a.Scale==NaN&&(a.Scale=1);var g=(a.width-a.offsetX)*a.Scale,h=a.height*a.Scale;if(g<a.width||a.Scale==1)a.currentOffsetX=a.offsetX,a.currentOffsetY=a.offsetY,a.currentWidth=a.width,a.currentHeight=a.height,a.canvasHeightUIAdjusted=a.height-a.offsetY-a.titleSpace,a.columnWidth=(a.width-a.offsetX)/a.buckets.length,a.Scale=1,$(".pv-viewarea-graphview-overlay div").fadeIn("slow"),a.dontZoom=!0,$(".pv-toolbarpanel-zoomslider").slider("option","value",0);else{a.currentOffsetX=b.x-(b.x-a.currentOffsetX)/c*a.Scale;var i=(b.y-a.currentOffsetY)/c*a.Scale;a.currentOffsetY=b.y-i,a.canvasHeightUIAdjusted=h-(a.offsetY+a.titleSpace)/c*a.Scale,a.currentWidth=g,a.currentHeight=h,a.columnWidth=g/a.buckets.length,$(".pv-viewarea-graphview-overlay div").fadeOut("slow")}a.rowscols=a.GetRowsAndColumns(a.columnWidth-2,a.canvasHeightUIAdjusted,a.maxRatio,a.bigCount),a.rowscols.TileHeight<10&&(a.rowscols.TileHeight=10),a.SetVisibleTileGraphPositions(a.rowscols,a.currentOffsetX,a.currentOffsetY,!0,!0);if(a.Scale==1&&c!=1){for(var j=0;j<a.tiles.length;j++)a.tiles[j].Selected(!1),a.tiles[j].selectedLoc=0;a.selected="",$.publish("/PivotViewer/Views/Item/Selected",[{id:a.selected,bkt:0}])}}),$.subscribe("/PivotViewer/Views/Canvas/Drag",function(b){if(!a.isActive)return;var c=b.x,d=b.y,e=!1,f=!1;a.currentOffsetX+=c,a.currentOffsetY+=d,c>0&&a.currentOffsetX>a.offsetX&&(a.currentOffsetX-=c,e=!0),d>0&&a.currentOffsetY+a.canvasHeightUIAdjusted>a.currentHeight+a.offsetY&&(a.currentOffsetY-=d,f=!0),a.currentOffsetX<a.offsetX&&a.currentWidth==a.width&&(a.currentOffsetX-=c,e=!0),c<0&&a.currentOffsetX<-1*(a.currentWidth-a.width)&&(a.currentOffsetX-=c,e=!0),a.currentOffsetY<a.offsetY&&a.currentHeight==a.height&&(a.currentOffsetY-=d,f=!0),d<0&&a.currentOffsetY-a.offsetY<-1*(a.currentHeight-a.height)&&(a.currentOffsetY-=d,f=!0);if(e&&f)return;e?a.OffsetTiles(0,d):f?a.OffsetTiles(c,0):a.OffsetTiles(c,d)})},Setup:function(a,b,c,d,e){this.width=a,this.height=b,this.offsetX=c,this.offsetY=d,this.maxRatio=e,this.currentWidth=this.width,this.currentHeight=this.height,this.currentOffsetX=this.offsetX,this.currentOffsetY=this.offsetY,this.rowscols=null,this.bigCount=0},Filter:function(a,b,c,d,e,f){var g=this;if(!Modernizr.canvas)return;Debug.Log("Graph View Filtered: "+b.length),this.changingView=!1,e&&($(".pv-tableview-table").is(":visible")&&($(".pv-tableview-table").fadeOut(),$(".pv-toolbarpanel-zoomslider").fadeIn(),$(".pv-toolbarpanel-zoomcontrols").css("border-width","1px"),$(".pv-viewarea-canvas").fadeIn()),$(".pv-mapview-canvas").is(":visible")&&($(".pv-mapview-canvas").fadeOut(),$(".pv-toolbarpanel-zoomslider").fadeIn(),$(".pv-toolbarpanel-zoomcontrols").css("border-width","1px"),$(".pv-viewarea-canvas").fadeIn())),this.sortFacet=c,this.tiles=a,this.tiles=a.sort(this.SortBy(this.sortFacet,!1,function(a){return $.isNumeric(a)?a:a.toUpperCase()},d)),this.currentFilter=b,this.buckets=this.Bucketize(a,b,this.sortFacet,d),this.columnWidth=(this.width-this.offsetX)/this.buckets.length,this.canvasHeightUIAdjusted=this.height-this.offsetY-this.titleSpace;var h=[];this.bigCount=0;for(var i=0;i<this.buckets.length;i++){var j=i%2==0?"graphview-bucket-dark":"graphview-bucket-light";h[i]="<div class='pv-viewarea-graphview-overlay-bucket "+j+"' id='pv-viewarea-graphview-overlay-bucket-"+i+"' style='width: "+(Math.floor(this.columnWidth)-4)+"px; height:"+(this.height-2)+"px; left:"+(i*this.columnWidth-2)+"px;'>",this.buckets[i].startRange==this.buckets[i].endRange?h[i]+="<div class='pv-viewarea-graphview-overlay-buckettitle' style='top: "+(this.canvasHeightUIAdjusted+4)+"px;'>"+this.buckets[i].startRange+"</div></div>":h[i]+="<div class='pv-viewarea-graphview-overlay-buckettitle' style='top: "+(this.canvasHeightUIAdjusted+4)+"px;'>"+this.buckets[i].startRange+"<br/>to<br/>"+this.buckets[i].endRange+"</div></div>",this.bigCount<this.buckets[i].Ids.length&&(this.bigCount=this.buckets[i].Ids.length)}var k=$(".pv-viewarea-graphview-overlay");k.css("left",this.offsetX+"px"),$(".pv-viewarea-graphview-overlay div").fadeOut("slow",function(){$(this).remove()}),k.append(h.join("")),$(".pv-viewarea-graphview-overlay div").fadeIn("slow");for(var i=0;i<this.tiles.length;i++){this.tiles[i]._locations[0].startx=this.tiles[i]._locations[0].x,this.tiles[i]._locations[0].starty=this.tiles[i]._locations[0].y,this.tiles[i].startwidth=this.tiles[i].width,this.tiles[i].startheight=this.tiles[i].height;var l=$.inArray(this.tiles[i].facetItem.Id,b);l<0&&(this.SetOuterTileDestination(this.width,this.height,this.tiles[i]),this.tiles[i].start=PivotViewer.Utils.Now(),this.tiles[i].end=this.tiles[i].start+1e3)}g.maxRatio=g.tiles[0]._controller.GetRatio(g.tiles[0].facetItem.Img);for(var i=0;i<g.tiles.length;i++){var l=$.inArray(g.tiles[i].facetItem.Id,b);l>=0&&g.tiles[i]._controller.GetRatio(g.tiles[i].facetItem.Img)<g.maxRatio&&(g.maxRatio=g.tiles[i]._controller.GetRatio(g.tiles[i].facetItem.Img))}var m=b.length==this.tiles.length?0:500;setTimeout(function(){var a=$(".pv-toolbarpanel-zoomslider").slider("option","value");a>0&&(this.selected=selectedItem="",this.currentOffsetX=this.offsetX,this.currentOffsetY=this.offsetY,$(".pv-toolbarpanel-zoomslider").slider("option","value",1)),g.rowscols=g.GetRowsAndColumns(g.columnWidth-2,g.canvasHeightUIAdjusted-g.offsetY,g.maxRatio,g.bigCount),g.rowscols.TileHeight<10&&(g.rowscols.TileHeight=10);for(var b=0;b<g.tiles.length;b++)g.tiles[b].origwidth=g.rowscols.TileHeight/g.tiles[b]._controller.GetRatio(g.tiles[b].facetItem.Img),g.tiles[b].origheight=g.rowscols.TileHeight;g.SetVisibleTileGraphPositions(g.rowscols,g.offsetX,g.offsetY,!1,!1)},m),this.init=!1},GetUI:function(){return Modernizr.canvas?"<div class='pv-viewarea-graphview-overlay'></div>":"<div class='pv-viewpanel-unabletodisplay'><h2>Unfortunately this view is unavailable as your browser does not support this functionality.</h2>Please try again with one of the following supported browsers: IE 9+, Chrome 4+, Firefox 2+, Safari 3.1+, iOS Safari 3.2+, Opera 9+<br/><a href='http://caniuse.com/#feat=canvas'>http://caniuse.com/#feat=canvas</a></div>"},GetButtonImage:function(){return"images/GraphView.png"},GetButtonImageSelected:function(){return"images/GraphViewSelected.png"},GetViewName:function(){return"Graph View"},GetSortedFilter:function(){var a=[];for(i=0;i<this.buckets.length;i++)for(j=0;j<this.buckets[i].Ids.length;j++){var b=new Object;b.Id=this.buckets[i].Ids[j],b.Bucket=i,a.push(b)}return a},SetVisibleTileGraphPositions:function(a,b,c,d,e){var f=e&&this.rowscols?this.rowscols.Columns:a.Columns;e||(this.rowscols=a);var g=[],h=[];for(var i=0;i<this.tiles.length;i++){this.tiles[i].firstFilterItemDone=!1;while(this.tiles[i]._locations.length>1)this.tiles[i]._locations.pop()}for(var j=0;j<this.buckets.length;j++){var k=0,l=0;for(var m=0,n=this.tiles.length;m<n;m++)$.inArray(this.tiles[m].facetItem.Id,this.buckets[j].Ids)>=0&&(this.tiles[m].firstFilterItemDone?(tileLocation=new PivotViewer.Views.TileLocation,tileLocation.startx=this.tiles[m]._locations[0].startx,tileLocation.starty=this.tiles[m]._locations[0].starty,tileLocation.x=this.tiles[m]._locations[0].x,tileLocation.y=this.tiles[m]._locations[0].y,tileLocation.destinationx=j*this.columnWidth+k*a.TileMaxWidth+b,tileLocation.destinationy=this.canvasHeightUIAdjusted-a.TileHeight-l*a.TileHeight+c,this.tiles[m]._locations.push(tileLocation)):(d&&(this.tiles[m]._locations[0].startx=this.tiles[m]._locations[0].x,this.tiles[m]._locations[0].starty=this.tiles[m]._locations[0].y,this.tiles[m].startwidth=this.tiles[m].width,this.tiles[m].startheight=this.tiles[m].height),this.tiles[m].destinationwidth=a.TileMaxWidth,this.tiles[m].destinationheight=a.TileHeight,this.tiles[m]._locations[0].destinationx=j*this.columnWidth+k*a.TileMaxWidth+b,this.tiles[m]._locations[0].destinationy=this.canvasHeightUIAdjusted-a.TileHeight-l*a.TileHeight+c,this.tiles[m].start=PivotViewer.Utils.Now(),this.tiles[m].end=this.tiles[m].start+1e3,this.tiles[m].firstFilterItemDone=!0),k==f-1?(k=0,l++):k++)}},Bucketize:function(a,b,c,d){var e=[];for(var f=0;f<a.length;f++)if($.inArray(a[f].facetItem.Id,b)>=0){var g=!1;for(var h=0;h<a[f].facetItem.Facets.length;h++)if(a[f].facetItem.Facets[h].Name==c&&a[f].facetItem.Facets[h].FacetValues.length>0)for(var i=0;i<a[f].facetItem.Facets[h].FacetValues.length;i++){var j=a[f].facetItem.Facets[h].FacetValues[i].Value,k=!1;for(var l=0;l<e.length;l++)e[l].startRange==j&&($.inArray(a[f].facetItem.Id,e[l].Ids)<0&&e[l].Ids.push(a[f].facetItem.Id),k=!0);k||e.push({startRange:j,endRange:j,Ids:[a[f].facetItem.Id],Values:[j]}),g=!0}if(!g){var j="(no info)",k=!1;for(var l=0;l<e.length;l++)e[l].startRange==j&&(e[l].Ids.push(a[f].facetItem.Id),e[l].Values.push(j),k=!0);k||e.push({startRange:j,endRange:j,Ids:[a[f].facetItem.Id],Values:[j]})}}if(d.length>0){var m;for(var n=0;n<d.length;n++)if(d[n].facet==c){m=n;break}if(m!=undefined&&m>=0){var o=[],p=d[m].facetValue;for(var q=0;q<e.length;q++){var r=$.inArray(e[q].startRange,p);r>=0&&o.push(e[q])}e=o}}var s=0;while(e.length>8)if(s<e.length-1){e[s].endRange=e[s+1].endRange;for(var f=0;f<e[s+1].Ids.length;f++)$.inArray(e[s+1].Ids[f],e[s].Ids)<0&&e[s].Ids.push(e[s+1].Ids[f]),$.inArray(e[s+1].endRange,e[s].Values)<0&&e[s].Values.push(e[s+1].endRange);e.splice(s+1,1),s++}else s=0;return e},GetSelectedCol:function(a,b){var c=this,d=0;for(i=0;i<b;i++)$.inArray(a.facetItem.Id,this.buckets[i].Ids)>0&&d++;return padding=c.rowscols.PaddingX,colsInBar=c.rowscols.Columns,tileMaxWidth=c.rowscols.TileMaxWidth,selectedBar=Math.floor((a._locations[d].x-c.currentOffsetX)/(tileMaxWidth*colsInBar+padding)),selectedColInBar=Math.round((a._locations[d].x-c.currentOffsetX-selectedBar*(colsInBar*tileMaxWidth+padding))/tileMaxWidth),selectedCol=selectedBar*colsInBar+selectedColInBar,selectedCol},GetSelectedRow:function(a,b){var c=this,d=0;for(i=0;i<b;i++)$.inArray(a.facetItem.Id,this.buckets[i].Ids)>0&&d++;return selectedRow=Math.round((c.canvasHeightUIAdjusted-(a._locations[d].y-c.currentOffsetY))/a.height),selectedRow},CentreOnSelectedTile:function(a,b){var c=this,d;for(var e=0;e<c.tiles.length;e++)if(c.tiles[e].IsSelected()){d=c.tiles[e];break}c.rowscols=c.GetRowsAndColumns(c.columnWidth-2,c.canvasHeightUIAdjusted,c.maxRatio,c.bigCount),c.rowscols.TileHeight<10&&(c.rowscols.TileHeight=10);var f=Math.floor(a/c.rowscols.Columns),g=c.rowscols.PaddingX*f;c.currentOffsetX=c.rowscols.TileMaxWidth*a*-1+c.width/2-c.rowscols.TileMaxWidth/2-g,c.currentOffsetY=-c.rowscols.TileHeight*(c.rowscols.Rows/2-(b+1))-c.canvasHeightUIAdjusted/2-c.rowscols.TileHeight/2,c.SetVisibleTileGraphPositions(c.rowscols,c.currentOffsetX,c.currentOffsetY,!0,!0)},handleSelection:function(a,b,c,d){var e=this,f=0,g=0,h=!1,i=!1,j=0,k=0;a!=null&&b!=null&&(selectedX=b._locations[d].x,selectedY=b._locations[d].y);if(a!=null&&e.selected!=a&&e.selected==""){var l=$(".pv-toolbarpanel-zoomslider").slider("option","value");l!=0&&$(".pv-toolbarpanel-zoomslider").slider("option","value",0)}a!=null&&b!=null&&(b.Selected(!0),b.selectedLoc=d,h=!0,padding=e.rowscols.PaddingX,colsInBar=e.rowscols.Columns,tileMaxWidth=e.rowscols.TileMaxWidth,selectedBar=Math.floor((b._locations[d].x-e.currentOffsetX)/(b.width*colsInBar+padding)),selectedColInBar=Math.round((b._locations[d].x-e.currentOffsetX-selectedBar*(colsInBar*tileMaxWidth+padding))/tileMaxWidth),f=selectedBar*colsInBar+selectedColInBar,g=Math.round((e.canvasHeightUIAdjusted-(b._locations[d].y-e.currentOffsetY))/b.height),tileHeight=b.height,tileWidth=b.height/b._controller.GetRatio(b.facetItem.Img),tileOrigHeight=b.origheight,tileOrigWidth=b.origwidth,canvasHeight=b.context.canvas.height,canvasWidth=b.context.canvas.width-($(".pv-filterpanel").width()+$(".pv-infopanel").width())),e.selected!=null&&e.selected!=""&&!h&&(i=!0);if(a!=null&&e.selected!=a){tileHeight/canvasHeight>tileWidth/canvasWidth?origProportion=tileOrigHeight/canvasHeight:origProportion=tileOrigWidth/canvasWidth,scale=Math.round(.75/origProportion*2);if(e.selected==""){var l=$(".pv-toolbarpanel-zoomslider").slider("option","value");l=scale,$(".pv-toolbarpanel-zoomslider").slider("option","value",l)}e.selected=a,e.CentreOnSelectedTile(f,g),$(".pv-viewarea-graphview-overlay div").fadeOut("slow")}else{e.selected=a="",selectedBar=0,e.currentOffsetX=e.offsetX,e.currentOffsetY=e.offsetY;var l=$(".pv-toolbarpanel-zoomslider").slider("option","value");l=0,$(".pv-toolbarpanel-zoomslider").slider("option","value",l),$(".pv-viewarea-graphview-overlay div").fadeIn("slow")}$.publish("/PivotViewer/Views/Item/Selected",[{id:a,bkt:selectedBar}]);if(!h&&!i){var m=Math.floor((c-e.offsetX)/e.columnWidth);$.publish("/PivotViewer/Views/Item/Filtered",[{Facet:e.sortFacet,Item:e.buckets[m].startRange,MaxRange:e.buckets[m].endRange,Values:e.buckets[m].Values,ClearFacetFilters:!0}])}}}),PivotViewer.Views.GridView=PivotViewer.Views.TileBasedView.subClass({init:function(){this.Scale=1,this._super(),this.dontZoom=!1;var a=this;$.subscribe("/PivotViewer/Views/Canvas/Click",function(b){if(!a.isActive)return;var c=null,d=null;for(var e=0;e<a.tiles.length;e++){var f=a.tiles[e].Contains(b.x,b.y);f>=0?(d=a.tiles[e],c=a.tiles[e].facetItem.Id):a.tiles[e].Selected(!1)}a.handleSelection(c,d)}),$.subscribe("/PivotViewer/Views/Canvas/Hover",function(b){if(!a.isActive||a.selected.length>0)return;for(var c=0;c<a.tiles.length;c++){var d=a.tiles[c].Contains(b.x,b.y);d>=0?a.tiles[c].Selected(!0):a.tiles[c].Selected(!1)}}),$.subscribe("/PivotViewer/Views/Canvas/Zoom",function(b){if(!a.isActive)return;if(a.dontZoom){a.dontZoom=!1;return}var c=a.Scale,d=a.currentWidth,e=a.currentHeight,f=b.scale!=undefined?0:1e3;b.scale!=undefined?b.scale>=1?a.Scale+=b.scale-1:(a.Scale-=b.scale,a.Scale=a.Scale<1?1:a.Scale):b.delta!=undefined&&(a.Scale=b.delta==0?1:a.Scale+b.delta-1),a.Scale==NaN&&(a.Scale=1);var g=(a.width-a.offsetX)*a.Scale,h=(a.height-a.offsetY)*a.Scale;if(g<a.width||a.Scale==1)a.currentOffsetX=a.offsetX,a.currentOffsetY=a.offsetY,a.currentWidth=a.width,a.currentHeight=a.height,a.Scale=1,a.dontZoom=!0,$(".pv-toolbarpanel-zoomslider").slider("option","value",0);else{var i=(b.x-a.currentOffsetX)/c*a.Scale,j=(b.y-a.currentOffsetY)/c*a.Scale;a.currentOffsetX=b.x-i,a.currentOffsetY=b.y-j,a.currentWidth=g,a.currentHeight=h}var k=a.GetRowsAndColumns(a.currentWidth-a.offsetX,a.currentHeight-a.offsetY,a.maxRatio,a.currentFilter.length);a.SetVisibleTilePositions(k,a.currentFilter,a.currentOffsetX,a.currentOffsetY,!0,!0,f);if(a.Scale==1&&c!=1){for(var l=0;l<a.tiles.length;l++)a.tiles[l].Selected(!1);a.selected="",$.publish("/PivotViewer/Views/Item/Selected",[{id:a.selected,bkt:0}])}}),$.subscribe("/PivotViewer/Views/Canvas/Drag",function(b){if(!a.isActive)return;var c=b.x,d=b.y,e=!1,f=!1;a.currentOffsetX+=c,a.currentOffsetY+=d,c>0&&a.currentOffsetX>a.offsetX&&(a.currentOffsetX-=c,e=!0),d>0&&a.currentOffsetY>a.offsetY&&(a.currentOffsetY-=d,f=!0),a.currentOffsetX<a.offsetX&&a.currentWidth==a.width&&(a.currentOffsetX-=c,e=!0),c<0&&a.currentOffsetX<-1*(a.currentWidth-a.width)&&(a.currentOffsetX-=c,e=!0),a.currentOffsetY<a.offsetY&&a.currentHeight==a.height&&(a.currentOffsetY-=d,f=!0),d<0&&a.currentOffsetY-a.offsetY<-1*(a.currentHeight-a.height)&&(a.currentOffsetY-=d,f=!0);if(e&&f)return;e?a.OffsetTiles(0,d):f?a.OffsetTiles(c,0):a.OffsetTiles(c,d)})},Setup:function(a,b,c,d,e){this.width=a,this.height=b,this.offsetX=c,this.offsetY=d,this.maxRatio=e,this.currentWidth=this.width,this.currentHeight=this.height,this.currentOffsetX=this.offsetX,this.currentOffsetY=this.offsetY},Filter:function(a,b,c,d,e,f){var g=this,h=!1;if(!Modernizr.canvas)return;Debug.Log("Grid View Filtered: "+b.length),this.changingView=!1,e&&($(".pv-tableview-table").is(":visible")&&(h=!0,$(".pv-tableview-table").fadeOut(),this.selected="",$(".pv-toolbarpanel-zoomslider").fadeIn(),$(".pv-toolbarpanel-zoomcontrols").css("border-width","1px"),$(".pv-viewarea-canvas").fadeIn(function(){$.publish("/PivotViewer/Views/ChangeTo/Grid",[{Item:f}])})),$(".pv-mapview-canvas").is(":visible")&&(h=!0,$(".pv-mapview-canvas").fadeOut(),this.selected="",$(".pv-toolbarpanel-zoomslider").fadeIn(),$(".pv-toolbarpanel-zoomcontrols").css("border-width","1px"),$(".pv-viewarea-canvas").fadeIn(function(){$.publish("/PivotViewer/Views/ChangeTo/Grid",[{Item:f}])}))),this.tiles=a,this.init&&this.SetInitialTiles(this.tiles,this.width,this.height);for(var i=0;i<this.tiles.length;i++)while(this.tiles[i]._locations.length>1)this.tiles[i]._locations.pop();for(var j=0;j<this.tiles.length;j++)this.tiles[j].selectedLoc=0;this.tiles=this.tiles.sort(this.SortBy(c,!1,function(a){return $.isNumeric(a)?a:a.toUpperCase()},d)),this.currentFilter=b;if(!h||f==""){var k=0;Debug.Log("this.currentWidth: "+this.currentWidth+" this.width: "+this.width);var l=$(".pv-toolbarpanel-zoomslider").slider("option","value");if(l>0){this.selected=selectedItem="",this.currentOffsetX=this.offsetX,this.currentOffsetY=this.offsetY,$(".pv-toolbarpanel-zoomslider").slider("option","value",1);var m=this.GetRowsAndColumns(this.currentWidth-this.offsetX,this.currentHeight-this.offsetY,this.maxRatio,this.tiles.length),n=[];for(var j=0;j<this.tiles.length;j++)this.tiles[j].origwidth=m.TileHeight/this.tiles[j]._controller.GetRatio(this.tiles[j].facetItem.Img),this.tiles[j].origheight=m.TileHeight,n.push(this.tiles[j].facetItem.Id);this.SetVisibleTilePositions(m,n,this.currentOffsetX,this.currentOffsetY,!0,!1,1e3),k=1e3}setTimeout(function(){for(var a=0;a<g.tiles.length;a++){g.tiles[a]._locations[0].startx=g.tiles[a]._locations[0].x,g.tiles[a]._locations[0].starty=g.tiles[a]._locations[0].y,g.tiles[a].startwidth=g.tiles[a].width,g.tiles[a].startheight=g.tiles[a].height;var c=$.inArray(g.tiles[a].facetItem.Id,b);c<0&&(g.SetOuterTileDestination(g.width,g.height,g.tiles[a]),g.tiles[a].start=PivotViewer.Utils.Now(),g.tiles[a].end=g.tiles[a].start+1e3)}g.maxRatio=g.tiles[0]._controller.GetRatio(g.tiles[0].facetItem.Img);for(var a=0;a<g.tiles.length;a++){var c=$.inArray(g.tiles[a].facetItem.Id,b);c>=0&&g.tiles[a]._controller.GetRatio(g.tiles[a].facetItem.Img)<g.maxRatio&&(g.maxRatio=g.tiles[a]._controller.GetRatio(g.tiles[a].facetItem.Img))}var d=b.length==g.tiles.length?0:500;setTimeout(function(){var a=g.GetRowsAndColumns(g.width-g.offsetX,g.height-g.offsetY,g.maxRatio,g.currentFilter.length);for(var b=0;b<g.tiles.length;b++)g.tiles[b].origwidth=a.TileHeight/g.tiles[b]._controller.GetRatio(g.tiles[b].facetItem.Img),g.tiles[b].origheight=a.TileHeight;g.SetVisibleTilePositions(a,g.currentFilter,g.offsetX,g.offsetY,!1,!1,1e3)},d)},k)}this.init=!1},GetUI:function(){return Modernizr.canvas?"":"<div class='pv-viewpanel-unabletodisplay'><h2>Unfortunately this view is unavailable as your browser does not support this functionality.</h2>Please try again with one of the following supported browsers: IE 9+, Chrome 4+, Firefox 2+, Safari 3.1+, iOS Safari 3.2+, Opera 9+<br/><a href='http://caniuse.com/#feat=canvas'>http://caniuse.com/#feat=canvas</a></div>"
},GetButtonImage:function(){return"images/GridView.png"},GetButtonImageSelected:function(){return"images/GridViewSelected.png"},GetViewName:function(){return"Grid View"},SetVisibleTilePositions:function(a,b,c,d,e,f,g){var h=f&&this.rowscols?this.rowscols.Columns:a.Columns;f||(this.rowscols=a);var i=0,j=0;for(var k=0;k<this.tiles.length;k++){var l=$.inArray(this.tiles[k].facetItem.Id,b);l>=0&&(e&&(this.tiles[k]._locations[0].startx=this.tiles[k]._locations[0].x,this.tiles[k]._locations[0].starty=this.tiles[k]._locations[0].y,this.tiles[k].startwidth=this.tiles[k].width,this.tiles[k].startheight=this.tiles[k].height),this.tiles[k].destinationwidth=a.TileMaxWidth,this.tiles[k].destinationheight=a.TileHeight,this.tiles[k]._locations[0].destinationx=i*a.TileMaxWidth+c,this.tiles[k]._locations[0].destinationy=j*a.TileHeight+d,this.tiles[k].start=PivotViewer.Utils.Now(),this.tiles[k].end=this.tiles[k].start+g,i==h-1?(i=0,j++):i++)}},GetSelectedCol:function(a){var b=this;return selectedCol=Math.round((a._locations[0].x-b.currentOffsetX)/a.width),selectedCol},GetSelectedRow:function(a){var b=this;return selectedRow=Math.round((a._locations[0].y-b.currentOffsetY)/a.height),selectedRow},CentreOnSelectedTile:function(a,b){var c=this,d;for(var e=0;e<c.tiles.length;e++)if(c.tiles[e].IsSelected()){d=c.tiles[e];break}var f=c.GetRowsAndColumns(c.currentWidth-c.offsetX,c.currentHeight-c.offsetY,c.maxRatio,c.currentFilter.length);c.currentOffsetX=f.TileMaxWidth*a*-1+c.width/2-f.TileMaxWidth/2,c.currentOffsetY=f.TileHeight*b*-1+c.height/2-f.TileHeight/2,c.SetVisibleTilePositions(f,c.currentFilter,c.currentOffsetX,c.currentOffsetY,!0,!0,1e3)},handleSelection:function(a,b){var c=this,d=0,e=0,f=0,g=0;a!=null&&b!=null&&(d=Math.round((b._locations[0].x-c.currentOffsetX)/b.width),e=Math.round((b._locations[0].y-c.currentOffsetY)/b.height));if(a!=null&&c.selected!=a&&c.selected==""){var h=$(".pv-toolbarpanel-zoomslider").slider("option","value");h!=0&&$(".pv-toolbarpanel-zoomslider").slider("option","value",0)}a!=null&&b!=null&&(b.Selected(!0),tileHeight=b.height,tileWidth=b.height/b._controller.GetRatio(b.facetItem.Img),tileOrigHeight=b.origheight,tileOrigWidth=b.origwidth,canvasHeight=b.context.canvas.height,canvasWidth=b.context.canvas.width-($(".pv-filterpanel").width()+$(".pv-infopanel").width()));if(a!=null&&c.selected!=a){tileHeight/canvasHeight>tileWidth/canvasWidth?origProportion=tileOrigHeight/canvasHeight:origProportion=tileOrigWidth/canvasWidth,scale=Math.round(.75/origProportion*2);if(c.selected==""){var h=$(".pv-toolbarpanel-zoomslider").slider("option","value");h=scale,$(".pv-toolbarpanel-zoomslider").slider("option","value",h)}c.selected=a,c.CentreOnSelectedTile(d,e)}else{c.selected=a="",c.currentOffsetX=c.offsetX,c.currentOffsetY=c.offsetY;var h=$(".pv-toolbarpanel-zoomslider").slider("option","value");h=0,$(".pv-toolbarpanel-zoomslider").slider("option","value",h)}$.publish("/PivotViewer/Views/Item/Selected",[{id:a,bkt:0}])}}),PivotViewer.Views.IImageController=Object.subClass({init:function(){},Setup:function(a){},GetImagesAtLevel:function(a,b){},Width:0,Height:0}),PivotViewer.Views.LoadImageSetHelper=Object.subClass({init:function(){this._images=[],this._loaded=!1},LoadImages:function(a){var b=this;for(var c=0;c<a.length;c++){var d=new Image;d.src=a[c],d.onload=function(){b._loaded=!0},this._images.push(d)}},GetImages:function(){return this._images},IsLoaded:function(){return this._loaded}}),PivotViewer.Views.MapView=PivotViewer.Views.IPivotViewerView.subClass({init:function(){this._super(),this.locCache=Array(),this.locList=Array(),this.inScopeLocList=Array(),this.map,this.markers=Array(),this.selectedItemId,this.geocodeList=Array(),this.itemsToGeocode=Array(),this.startGeocode,this.geocodeZero,this.mapInitZoom="",this.mapInitType="",this.mapInitCentreX="",this.mapInitCentreY="",this.mapZoom="",this.mapType="",this.mapCentreX="",this.mapCentreY="",this.applyBookmark=!1;var a=this},Setup:function(a,b,c,d,e){this.width=a,this.height=b,this.offsetX=c,this.offsetY=d,this.currentWidth=this.width,this.currentHeight=this.height,this.currentOffsetX=this.offsetX,this.currentOffsetY=this.offsetY,Modernizr.localstorage?this.localStorage=!0:this.localStorage=!1},Filter:function(a,b,c,d,e,f){var g=this,h=0;if(!Modernizr.canvas)return;Debug.Log("Map View Filtered: "+b.length),e&&($(".pv-viewarea-canvas").fadeOut(),$(".pv-tableview-table").fadeOut(),$(".pv-toolbarpanel-zoomslider").fadeOut(),$(".pv-toolbarpanel-zoomcontrols").css("border-width","0"),$(".pv-mapview-canvas").fadeIn(function(){f&&$.publish("/PivotViewer/Views/Item/Selected",[{id:f.Id,bkt:0}])})),this.tiles=a,this.currentFilter=b,this.selectedItemId="",this.inScopeLocList=[];for(var i=0;i<b.length;i++)for(var j=0;j<this.tiles.length;j++)if(this.tiles[j].facetItem.Id==b[i]){var l,m,n=!1,o=!1,p=!1,q=!1,r=this.tiles[j].facetItem.Id,s=this.tiles[j].facetItem.Name;for(var t=0;t<this.locList.length;t++)if(this.locList[t].id==r){(this.locList[t].loc.lat()!=0||this.locList[t].loc.lng()!=0)&&this.inScopeLocList.push(this.locList[t]),q=!0;break}if(!q){for(k=0;k<this.tiles[j].facetItem.Facets.length;k++)if(this.tiles[j].facetItem.Facets[k].Name.toUpperCase().indexOf("LATITUDE")>=0){var u=this.GetFacetCategoryType(this.tiles[j].facetItem.Facets[k].Name);if(u=="String")l=parseFloat(this.tiles[j].facetItem.Facets[k].FacetValues[0].Value);else{if(u!="Number")break;l=this.tiles[j].facetItem.Facets[k].FacetValues[0].Value}n=!0;if(o){var v=new google.maps.LatLng(l,m);this.locList.push({id:r,loc:v,title:s}),this.inScopeLocList.push({id:r,loc:v,title:s}),p=!0;break}}else if(this.tiles[j].facetItem.Facets[k].Name.toUpperCase().indexOf("LONGITUDE")>=0){var u=this.GetFacetCategoryType(this.tiles[j].facetItem.Facets[k].Name);if(u=="String")m=parseFloat(this.tiles[j].facetItem.Facets[k].FacetValues[0].Value);else{if(u!="Number")break;m=this.tiles[j].facetItem.Facets[k].FacetValues[0].Value}o=!0;if(n){var v=new google.maps.LatLng(l,m);this.locList.push({id:r,loc:v,title:s}),this.inScopeLocList.push({id:r,loc:v,title:s}),p=!0;break}}if(!p)for(var w=0;w<this.tiles[j].facetItem.Facets.length;w++)if(this.tiles[j].facetItem.Facets[w].Name.toUpperCase().indexOf("LOCATION")>=0){for(var x=0;x<this.tiles[j].facetItem.Facets[w].FacetValues.length;x++){var y=this.tiles[j].facetItem.Facets[w].FacetValues[x].Value,z=!1;if(y.toUpperCase().indexOf("POINT(")==0){m=y.substring(6,y.indexOf(" ",6)-6),l=y.substring(y.indexOf(" ",6)+1,y.indexOf(")")-(y.indexOf(" ")+1));if(l!="NaN"&&m!="NaN"){var A=parseFloat(l),B=parseFloat(logitude);if(!isNaN(A)&&!isNaN(B)){var v=new google.maps.LatLng(A,B);locList.push({id:r,loc:v,title:s}),inScopeList.push({id:r,loc:v,title:s}),p=!0;break}}else z=!0}else if(y.indexOf(",")>-1){var A=parseFloat(y.substring(0,y.indexOf(","))),B=parseFloat(y.substring(y.indexOf(",")));if(!isNaN(A)&&!isNaN(B)){var v=new google.maps.LatLng(A,B);locList.push({id:r,loc:v,title:s}),inScopeList.push({id:r,loc:v,title:s}),p=!0;break}z=!0}if(!z&&y.length>1){var C=y.replace("_"," ").toUpperCase();for(var D=0;D<this.tiles[j].facetItem.Facets.length;D++)if(this.tiles[j].facetItem.Facets[D].Name.toUpperCase().indexOf("REGION")>=0){var E=this.tiles[j].facetItem.Facets[D].FacetValues[0].Value;E.length>1&&(C=C+", "+E.replace("_"," ").toUpperCase());break}for(var F=0;F<this.tiles[j].facetItem.Facets.length;F++)if(this.tiles[j].facetItem.Facets[F].Name.toUpperCase().indexOf("COUNTRY")>=0){var G=this.tiles[j].facetItem.Facets[F].FacetValues[0].Value;G.length>1&&(C=C+", "+G.replace("_"," ").toUpperCase());break}for(var H=0;H<this.locCache.length;H++)if(this.locCache[H].locName==C){this.locList.push({id:r,loc:this.locCache[H].loc,title:s}),this.inScopeLocList.push({id:r,loc:this.locCache[H].loc,title:s}),p=!0;break}if(!p){if(this.localStorage){var I,v=JSON.parse(localStorage.getItem(C)),A=parseFloat(v.lat),J=parseFloat(v.lng);!NaN(A)&&!NaN(J)&&(I=new google.maps.LatLng(A,J),this.locCache.push({locName:C,loc:I}),this.locList.push({id:r,loc:I,title:s}),this.inScopeLocList.push({id:r,loc:I,title:s}),p=!0)}if(!p&&h<1e3){var K=!1;for(var h=0;h<this.geocodeList.length;h++)if(this.geocodeList[h]==C){K=!0;break}K||(this.geocodeList.push(C),h++),this.itemsToGeocode.push({id:r,locName:C,title:s}),p=!0;break}}}}if(p)break}}}if(this.inScopeLocList.length==0&&h==0){this.ShowMapError();return}h>0&&this.GetLocationsFromNames(),$(".pv-mapview-canvas").css("height",this.height-12+"px"),$(".pv-mapview-canvas").css("width",this.width-415+"px"),f?this.CreateMap(f.Id):this.CreateMap("")},GetUI:function(){return""},GetButtonImage:function(){return"images/MapView.png"},GetButtonImageSelected:function(){return"images/MapViewSelected.png"},GetViewName:function(){return"Map View"},MakeGeocodeCallBack:function(a){var b=this,c=function(c,d){var e=new google.maps.LatLng(0,0),f=e;if(d==google.maps.GeocoderStatus.OK)var f=c[0].geometry.location;else var f=e;b.locCache.push({locName:a,loc:f});if(this.localStorage){var g={lat:f.lat(),lng:f.lng()};localStorage.setItem(a,JSON.stringify(g))}for(var h=0;h<b.itemsToGeocode.length;h++){var i=b.itemsToGeocode[h].id,j=b.itemsToGeocode[h].locName,k=b.itemsToGeocode[h].title;j==a&&(b.locList.push({id:i,loc:f,title:k}),(f.lat()!=0||f.lng()!=0)&&b.inScopeLocList.push({id:i,loc:f,title:k}))}var l=!0;for(var m=0;m<b.geocodeList.length;m++){var j=b.geocodeList[m],n=!0;for(var o=0;o<b.locCache.length;o++)if(b.locCache[o].locName==j){n=!1;break}if(n){l=!1;break}}var p=new Date;(p.getTime()-b.geocodeZero.getTime())/1e3>20?(b.RedrawMarkers(b.selectedItemId),b.startGeocode=new Date):(p.getTime()-b.startGeocode.getTime())/1e3>2&&(b.RedrawMarkers(b.selectedItemId),b.RefitBounds(),b.startGeocode=new Date);if(l||b.geocodeList.Count==0){b.geocodeList=[];if(b.inScopeLocList.Count==0){this.ShowMapError();return}b.CreateMap(b.selectedItemId),b.applyBookmark&&(b.SetBookmark(),b.applyBookmark=!1)}};return c},GetLocationsFromNames:function(){var a=new google.maps.Geocoder,b=this;for(l=0;l<this.itemsToGeocode.length;l++){var c=this.itemsToGeocode[l].locName;a.geocode({address:c},this.MakeGeocodeCallBack(c))}this.startGeocode=new Date,this.startGeocode.setSeconds(this.startGeocode.getSeconds()+2),this.geocodeZero=new Date},CreateMap:function(a){var b=this,c,d=8,e=google.maps.MapTypeId.ROADMAP,f=!1;centreLat=parseFloat(this.mapCentreX),centreLng=parseFloat(this.mapCentreY),!isNaN(centreLat)&&!isNaN(centreLng)&&(c=new google.maps.LatLng(centreLat,centreLng),f=!0),bookmarkZoom=parseInt(this.mapZoom),isNaN(bookmarkZoom)||(d=bookmarkZoom),this.mapType&&this.mapType!=""&&(e=this.mapType),this.map=new google.maps.Map(document.getElementById("pv-map-canvas")),f?this.map.panTo(c):this.selectedItemId&&this.CentreOnSelected(this.selectedItemId),this.map.setMapTypeId(e),this.map.setZoom(d),google.maps.event.addListener(this.map,"maptypeid_changed",function(){b.SetMapType(b.map.getMapTypeId()),$.publish("/PivotViewer/Views/Item/Updated",null)}),google.maps.event.addListener(this.map,"zoom_changed",function(){b.SetMapZoom(b.map.getZoom()),$.publish("/PivotViewer/Views/Item/Updated",null)}),google.maps.event.addListener(this.map,"center_changed",function(){var a=b.map.getCenter();b.SetMapCentreX(a.lat()),b.SetMapCentreY(a.lng()),$.publish("/PivotViewer/Views/Item/Updated",null)}),this.CreateMarkers(),this.RefitBounds()},SetFacetCategories:function(a){this.categories=a.FacetCategories},GetFacetCategoryType:function(a){for(i=0;i<this.categories.length;i++)if(this.categories[i].Name==a)return this.categories[i].Type;return"not set"},CreateMarkers:function(){var a=this;for(var b=0;b<this.markers.length;b++)this.markers[b].setMap(null);this.markers=[];for(b=0;b<this.inScopeLocList.length;b++)marker=new google.maps.Marker({position:this.inScopeLocList[b].loc,map:this.map,icon:"http://maps.google.com/mapfiles/ms/icons/red-dot.png",title:this.inScopeLocList[b].title}),this.inScopeLocList[b].id==this.selectedItemId&&(marker.setIcon("http://maps.google.com/mapfiles/ms/icons/green-dot.png"),marker.setZIndex(1e9)),google.maps.event.addListener(marker,"click",function(b,c){return function(){if(a.selectedItemId==a.inScopeLocList[c].id)b.setIcon("http://maps.google.com/mapfiles/ms/icons/red-dot.png"),a.selectedItemId="",$.publish("/PivotViewer/Views/Update/GridSelection",[{selectedItem:a.selectedItemId,selectedTile:selectedTile}]);else{a.selectedItemId=a.inScopeLocList[c].id;for(var d=0;d<a.tiles.length;d++)if(a.tiles[d].facetItem.Id==a.selectedItemId){selectedTile=a.tiles[d],$.publish("/PivotViewer/Views/Update/GridSelection",[{selectedItem:a.selectedItemId,selectedTile:selectedTile}]);break}}}}(marker,b)),this.markers.push(marker)},RefitBounds:function(){var a=new google.maps.LatLngBounds;for(i=0;i<this.markers.length;i++)a.extend(this.markers[i].position);this.map.fitBounds(a),this.currentFilter.length==1&&this.map.getZoom()>15&&this.map.setZoom(15)},RedrawMarkers:function(a){this.selectedItemId=a;for(var b=0;b<this.markers.length;b++)this.markers[b].setMap(null);this.markers=[],this.CreateMarkers(),this.CentreOnSelected(a)},ShowMapError:function(){var a="";a+="The current data selection does not contain any location information that can be shown on a map<br><br>",a+="<br>Choose a different view<br>",$(".pv-wrapper").append('<div id="pv-dzlocation-error" class="pv-modal-dialog"><div><a href="#pv-modal-dialog-close" title="Close" class="pv-modal-dialog-close">X</a><h2>HTML5 PivotViewer</h2><p>'+a+"</p></div></div>");var b=setTimeout(function(){window.open("#pv-dzlocation-error","_self")},1e3);return},GetMapCentreX:function(){return this.mapCentreX},SetMapCentreX:function(a){this.mapCentreX=a},SetMapInitCentreX:function(a){this.mapCentreX=a,this.mapInitCentreX=a},GetMapCentreY:function(){return this.mapCentreY},SetMapCentreY:function(a){this.mapCentreY=a},SetMapInitCentreY:function(a){this.mapCentreY=a,this.mapInitCentreY=a},GetMapType:function(){return this.mapType},SetMapType:function(a){this.mapType=a},SetMapInitType:function(a){this.mapType=a,this.mapInitType=a},GetMapZoom:function(){return this.mapZoom},SetMapZoom:function(a){this.mapZoom=a},SetMapInitZoom:function(a){this.mapZoom=a,this.mapInitZoom=a},CentreOnSelected:function(a){for(j=0;j<this.locList.length;j++)this.locList[j].id==a&&this.locList[j].loc.lat()!=0&&this.locList[j].loc.lng()!=0&&this.map.panTo(this.locList[j].loc)},SetBookmark:function(){var a,b=8,c=google.maps.MapTypeId.ROADMAP,d=!1;centreLat=parseFloat(this.mapInitCentreX),centreLng=parseFloat(this.mapInitCentreY),!isNaN(centreLat)&&!isNaN(centreLng)&&centreLat!=0&&centreLng!=0&&(a=new google.maps.LatLng(centreLat,centreLng),d=!0),bookmarkZoom=parseInt(this.mapInitZoom),isNaN(bookmarkZoom)||(b=bookmarkZoom),this.mapInitType&&this.mapInitType!=""&&(c=this.mapInitType),d&&this.map.panTo(a),this.map.setMapTypeId(c),this.map.setZoom(b)}}),PivotViewer.Views.TableView=PivotViewer.Views.IPivotViewerView.subClass({init:function(){this._super();var a=this,b,c="",d="",e="pv-key",f=!0,g=!0,h=!0},Setup:function(a,b,c,d,e){this.width=a,this.height=b,this.offsetX=c,this.offsetY=d,this.currentWidth=this.width,this.currentHeight=this.height,this.currentOffsetX=this.offsetX,this.currentOffsetY=this.offsetY,$(".pv-viewpanel").append("<div style='visibility:hidden;position:relative;' id='pv-table-loader'><img src='images/loading.gif'></img></div>"),$("#pv-table-loader").css("top",this.height/2-33+"px"),$("#pv-table-loader").css("left",this.width/2-43+"px")},Filter:function(a,b,c,d,e,f){var g=this;if(!Modernizr.canvas)return;Debug.Log("Table View Filtered: "+b.length),e&&($(".pv-viewarea-canvas").fadeOut(),$(".pv-mapview-canvas").fadeOut(),$(".pv-toolbarpanel-zoomslider").fadeOut(),$(".pv-toolbarpanel-zoomcontrols").css("border-width","0"),$(".pv-tableview-table").fadeIn(function(){f&&$.publish("/PivotViewer/Views/Item/Selected",[{id:f.Id,bkt:0}])})),this.tiles=a,this.currentFilter=b,this.selectedId="",this.sortReverseEntity=!0,this.sortReverseAttribute=!0,this.sortReverseValue=!0,this.CreateTable(b,this.selectedFacet),this.init=!1},GetUI:function(){return Modernizr.canvas?"":"<div class='pv-viewpanel-unabletodisplay'><h2>Unfortunately this view is unavailable as your browser does not support this functionality.</h2>Please try again with one of the following supported browsers: IE 9+, Chrome 4+, Firefox 2+, Safari 3.1+, iOS Safari 3.2+, Opera 9+<br/><a href='http://caniuse.com/#feat=canvas'>http://caniuse.com/#feat=canvas</a></div>"},GetButtonImage:function(){return"images/TableView.png"},GetButtonImageSelected:function(){return"images/TableViewSelected.png"},GetViewName:function(){return"Table View"},CellClick:function(a,b){Debug.Log("CellClick");if(a=="pv-key"){var c=b[0].textContent.trim(),d=-1;for(var e=0;e<this.tiles.length;e++)if(this.tiles[e].facetItem.Name==c){d=this.tiles[e].facetItem.Id;break}d>=0&&d!=this.selectedId?(this.selectedId=d,$.publish("/PivotViewer/Views/Item/Selected",[{id:d,bkt:0}])):d>=0&&d==this.selectedId&&(this.selectedId="",$.publish("/PivotViewer/Views/Item/Selected",[{id:"",bkt:0}]))}else if(a=="pv-facet"){var f=[];this.selectedId==""||this.selectedId==null?f=this.currentFilter:f[0]=this.selectedId,this.selectedFacet==""||this.selectedFacet==null?(this.selectedFacet=b[1].textContent.trim(),this.CreateTable(f,this.selectedFacet,this.sortKey)):(this.selectedFacet="",this.CreateTable(f,"")),$.publish("/PivotViewer/Views/Item/Updated",null)}else a=="pv-value"&&$.publish("/PivotViewer/Views/Item/Filtered",[{Facet:b[1].textContent.trim(),Item:b[2].textContent.trim(),Values:null,ClearFacetFilters:!0}])},CreateTable:function(a,b,c,d){var e=this,f=$("#pv-table"),g=!1,h=new Array,i=0;f.empty();var j,m;if(b==null||b==""||typeof b==undefined)g=!0;$(".pv-tableview-table").css("height",this.height-12+"px"),$(".pv-tableview-table").css("width",this.width-415+"px"),d?j="images/sort-up.png":j="images/sort-down.png";var n="odd-row",o="<table id='pv-table-data' style='color:#484848;'><tr class='pv-tableview-heading'><th id='pv-key' class='tooltipcustom' title='Sort on item name'>Item";c=="pv-key"&&(o+=" <img style='position:relative;top:"+m+"' src='"+j+"'></img>"),o+="</th><th class='tooltipcustom' id='pv-facet' title='Sort on relation name'>Relation",c=="pv-facet"&&(o+=" <img style='position:relative;top:"+m+"' src='"+j+"'></img>"),o+="</th><th id='pv-value' class='tooltipcustom' title='Sort on value'>Value",c=="pv-value"&&(o+=" <img style='position:relative;top:"+m+"' src='"+j+"'></img>"),o+="</th></tr>";for(var p=0;p<a.length;p++)for(var q=0;q<this.tiles.length;q++)if(this.tiles[q].facetItem.Id==a[p]){var r=this.tiles[q].facetItem.Name;if(g||b=="Description"){var s;c=="pv-key"?s=r:c=="pv-facet"?s="Description":c=="pv-value"&&(s=this.tiles[q].facetItem.Description),this.tiles[q].facetItem.Description&&(this.tiles[q].facetItem.Href?h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipinter' title='Toggle item selection' style='color:#009933;cursor:pointer'>"+r+" "+"<a href="+this.tiles[q].facetItem.Href.replace(/'/g,"%27")+" target=\"_blank\"><img style='cursor:default;' id='pv-linkout' title='Follow the link' title='Follow the link' src='images/goout.gif'></img></a></a></td><td id='pv-facet' class='tooltipcustom' title='Show only this relation' style='color:#009933;cursor:pointer'>Description</td><td id='pv-value'>"+this.tiles[q].facetItem.Description+"</td></tr>"}):h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltip' title='Toggle item selection'>"+r+"</td><td id='pv-facet' class='tooltipcustom' title='Show only this relation' style='color:#009933;cursor:pointer'>Description</td><td id='pv-value'>"+this.tiles[q].facetItem.Description+"</td></tr>"}),n="even-row")}n=="odd-row"?n="even-row":n="odd-row";if(g)for(k=0;k<this.tiles[q].facetItem.Facets.length;k++){var t=this.tiles[q].facetItem.Facets[k].Name;for(l=0;l<this.tiles[q].facetItem.Facets[k].FacetValues.length;l++){var u=this.tiles[q].facetItem.Facets[k].FacetValues[l].Value,s;c=="pv-key"?s=r:c=="pv-facet"?s=t:c=="pv-value"&&(s=u),this.IsFilterVisible(t)?this.tiles[q].facetItem.Href?this.IsUri(u)?h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipinter' title='Toggle item selection' style='color:#009933;cursor:pointer'>"+r+" "+"<a href="+this.tiles[q].facetItem.Href.replace(/'/g,"%27")+" target=\"_blank\"><img style='cursor:default;' id='pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td><td id='pv-facet' class='tooltipcustom'  title='Show only this relation' style='color:#009933;cursor:pointer'>"+t+"</td><td id='pv-value' class='tooltipinter' title='Filter on this value' style='color:#009933;cursor:pointer'>"+u+" "+"<a href="+u+" target=\"_blank\"><img style='cursor:default;' id=pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td></tr>"}):h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipinter' title='Toggle item selection' style='color:#009933;cursor:pointer'>"+r+" "+"<a href="+this.tiles[q].facetItem.Href.replace(/'/g,"%27")+" target=\"_blank\"><img style='cursor:default;' id='pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td><td id='pv-facet' class='tooltipcustom'  title='Show only this relation' style='color:#009933;cursor:pointer'>"+t+"</td><td id='pv-value' class='tooltipinter' title='Filter on this value' style='color:#009933;cursor:pointer'>"+u+"</td></tr>"}):this.IsUri(u)?h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipcustom' title='Toggle item selection'>"+r+"</td><td id='pv-facet' class='tooltipcustom'  title='Show only this relation'> style='color:#009933;cursor:pointer'"+t+"</td><td id='pv-value' class='tooltipinter' title='Filter on this value' style='color:#009933;cursor:pointer'>"+u+" "+"<a href="+u+" target=\"_blank\"><img style='cursor:default;' id=pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td></tr>"}):h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipcustom' title='Toggle item selection'>"+r+"</td><td id='pv-facet' class='tooltipcustom'  title='Show only this relation'> style='color:#009933;cursor:pointer'"+t+"</td><td id='pv-value' class='tooltipinter'  title='Filter on this value' style='color:#009933;cursor:pointer'>"+u+"</td></tr>"}):this.tiles[q].facetItem.Href?this.IsUri(u)?h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipinter' title='Toggle item selection' style='color:#009933;cursor:pointer'>"+r+" "+"<a href="+this.tiles[q].facetItem.Href.replace(/'/g,"%27")+" target=\"_blank\"><img style='cursor:default;' id='pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td><td id='pv-facet' class='tooltipcustom' title='Show only this relation'> style='color:#009933;cursor:pointer'"+t+"</td><td id='pv-value'><a href="+u+">"+u+"</a></td></tr>"}):h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipinter' title='Toggle item selection' style='color:#009933;cursor:pointer'>"+r+" "+"<a href="+this.tiles[q].facetItem.Href.replace(/'/g,"%27")+" target=\"_blank\"><img style='cursor:default;' id='pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td><td id='pv-facet' class='tooltipcustom' title='Show only this relation'> style='color:#009933;cursor:pointer'"+t+"</td><td id='pv-value'>"+u+"</td></tr>"}):this.IsUri(u)?h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipcustom' title='Select this value'>"+r+"</td><td id='pv-facet' class='tooltipcustom' title='Show only this relation'> style='color:#009933;cursor:pointer'"+t+"</td><td id='pv-value'><a href"+u+">"+u+"</a></td></tr>"}):h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipcustom' title='Select this value'>"+r+"</td><td id='pv-facet' class='tooltipcustom' title='Show only this relation'> style='color:#009933;cursor:pointer'"+t+"</td><td id='pv-value'>"+u+"</td></tr>"}),n=="odd-row"?n="even-row":n="odd-row"}}else for(k=0;k<this.tiles[q].facetItem.Facets.length;k++){var t=this.tiles[q].facetItem.Facets[k].Name;if(t==b){for(l=0;l<this.tiles[q].facetItem.Facets[k].FacetValues.length;l++){var u=this.tiles[q].facetItem.Facets[k].FacetValues[l].Value,s;c=="pv-key"?s=r:c=="pv-facet"?s=t:c=="pv-value"&&(s=u),this.IsFilterVisible(t)?this.tiles[q].facetItem.Href?this.IsUri(u)?h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipinter' title='Toggle item selection' style='color:#009933;cursor:pointer'>"+r+" "+"<a href="+this.tiles[q].facetItem.Href.replace(/'/g,"%27")+" target=\"_blank\"><img style='cursor:default;' id='pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td><td id='pv-facet' class='tooltipcustom' title='Clear relation selection' style='color:#009933;cursor:pointer'>"+t+"</td><td id='pv-value' class='tooltipinter 'title='Filter on this value' style='color:#009933;cursor:pointer'>"+u+" "+"<a href="+u+" target=\"_blank\"><img style='cursor:default;' id=pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td></tr>"}):h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipinter' title='Toggle item selection' style='color:#009933;cursor:pointer'>"+r+" "+"<a href="+this.tiles[q].facetItem.Href.replace(/'/g,"%27")+" target=\"_blank\"><img style='cursor:default;' id='pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td><td id='pv-facet' class='tooltipcustom' title='Clear relation selection' style='color:#009933;cursor:pointer'>"+t+"</td><td id='pv-value' class='tooltipinter' title='Filter on this value' style='color:#009933;cursor:pointer'>"+u+"</td></tr>"}):this.IsUri(u)?h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipcustom' title='Toggle item selection'>"+r+"</td><td id='pv-facet' class-'tooltipcustom' title='Clear relation selection' style='color:#009933;cursor:pointer'>"+t+"</td><td id='pv-value' class='tooltipinter' title='Filter on this value' style='color:#009933;cursor:pointer'>"+u+" "+"<a href="+u+" target=\"_blank\"><img style='cursor:default;' id=pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td></tr>"}):h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipcustom' title='Toggle item selection'>"+r+"</td><td id='pv-facet' class-'tooltipcustom' title='Clear relation selection' style='color:#009933;cursor:pointer'>"+t+"</td><td id='pv-value' class='tooltipinter' title='Filter on this value' style='color:#009933;cursor:pointer'>"+u+"</td></tr>"}):this.tiles[q].facetItem.Href?this.IsUri(u)?h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipinter' title='Click the cell to select this item' style='color:#009933;cursor:pointer'>"+r+" "+"<a href="+this.tiles[q].facetItem.Href.replace(/'/g,"%27")+" target=\"_blank\"><img style='cursor:default;' id='pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td><td id='pv-facet' class='tooltipcustom' title='Clear relation selection' style='color:#009933;cursor:pointer'>"+t+"</td><td id='pv-value'><a href="+u+">"+u+"</a></td></tr>"}):h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipinter' title='Click the cell to select this item' style='color:#009933;cursor:pointer'>"+r+" "+"<a href="+this.tiles[q].facetItem.Href.replace(/'/g,"%27")+" target=\"_blank\"><img style='cursor:default;' id='pv-linkout' title='Follow the link' src='images/goout.gif'></img></a></td><td id='pv-facet' class='tooltipcustom' title='Clear relation selection' style='color:#009933;cursor:pointer'>"+t+"</td><td id='pv-value'>"+u+"</td></tr>"}):this.IsUri(u)?h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipcustom' title='Toggle item selection'>"+r+"</td><td id='pv-facet' class-'tooltipcustom' title='Clear relation selection' style='color:#009933;cursor:pointer'>"+t+"</td><td id='pv-value'><a href"+u+">"+u+"</a></td></tr>"}):h.push({key:s,value:"<tr class='pv-tableview-"+n+"'><td id='pv-key' class='tooltipcustom' title='Toggle item selection'>"+r+"</td><td id='pv-facet' class-'tooltipcustom' title='Clear relation selection' style='color:#009933;cursor:pointer'>"+t+"</td><td id='pv-value'>"+u+"</td></tr>"}),n=="odd-row"?n="even-row":n="odd-row"}break}}}if(h.length==0)this.CreateTable(a,"",c,d);else{h.sort(function(a,b){return a.key>b.key?1:a.key<b.key?-1:0}),d&&h.reverse();for(var p=0;p<h.length;p++)o+=h[p].value;o+="</table>",f.append(o),$("#pv-table-data").colResizable({disable:!0}),$("#pv-table-data").colResizable({disable:!1}),$(".pv-tableview-heading").on("click",function(a){$("#pv-table-loader").show();var b=a.originalEvent.target.id,c=[];$(".tooltipinter").tooltipster("hide"),$(".tooltipcustom").tooltipster("hide"),e.selectedId==""||e.selectedId==null?c=e.currentFilter:c[0]=e.selectedId;var d;b=="pv-key"?(e.sortReverseEntity?d=!1:d=!0,e.sortReverseEntity=d):b=="pv-facet"?(e.sortReverseAttribute?d=!1:d=!0,e.sortReverseAttribute=d):b=="pv-value"&&(e.sortReverseValue?d=!1:d=!0,e.sortReverseValue=d),e.sortKey=b,e.CreateTable(c,e.selectedFacet,b,d),$("#pv-table-loader").fadeOut()}),$(".pv-tableview-odd-row").on("click",function(a){$("#pv-table-loader").show(),$(".tooltipinter").tooltipster("hide"),$(".tooltipcustom").tooltipster("hide");var b=a.originalEvent.target.id;e.CellClick(b,a.currentTarget.cells),$("#pv-table-loader").fadeOut()}),$(".pv-tableview-even-row").on("click",function(a){$("#pv-table-loader").show(),$(".tooltipinter").tooltipster("hide"),$(".tooltipcustom").tooltipster("hide");var b=a.originalEvent.target.id;e.CellClick(b,a.currentTarget.cells),$("#pv-table-loader").fadeOut()})}},Selected:function(a){var b=[];a==""||a==null||typeof a==undefined?(this.selectedId="",this.CreateTable(this.currentFilter,this.selectedFacet)):(b[0]=a,this.selectedId=a,this.CreateTable(b,this.selectedFacet))},SetFacetCategories:function(a){this.categories=a.FacetCategories},IsFilterVisible:function(a){var b=null;for(i=0;i<this.categories.length;i++)this.categories[i].Name==a&&(b=this.categories[i].IsFilterVisible);return b!=null?b:!1},IsUri:function(a){var b=a,c=!1;return typeof a=="string"&&(b.substring(0,5)=="http:"&&(c=!0),b.substring(0,6)=="https:"&&(c=!0)),c},SetSelectedFacet:function(a){this.selectedFacet=a},GetSelectedFacet:function(){return this.selectedFacet}}),PivotViewer.Views.TileController=Object.subClass({init:function(a){this._tiles=[],this._helpers=[],this._helperText="",this._easing=new Easing.Easer({type:"circular",side:"both"}),this._imageController=a},initTiles:function(a,b,c){for(var d=0;d<a.length;d++){var e=new PivotViewer.Views.Tile(this._imageController);e.facetItem=a[d],e.CollectionRoot=b.replace(/\\/gi,"/").replace(/\.xml/gi,""),this._canvasContext=c,e.context=this._canvasContext,tileLocation=new PivotViewer.Views.TileLocation,e._locations.push(tileLocation),this._tiles.push(e)}return this._tiles},AnimateTiles:function(a,b){var c=this;this._started=!0;var d=null,e=!1;if(this._tiles.length>0&&this._tiles[0].context!=null){d=this._tiles[0].context;var f=!1;for(var g=0;g<this._tiles.length;g++)for(k=0;k<this._tiles[g]._locations.length;k++){var h=PivotViewer.Utils.Now()-this._tiles[g].start,i=this._tiles[g].end-this._tiles[g].start;if(h<=i){if(this._tiles[g]._locations[k].x!=this._tiles[g]._locations[k].destinationx||this._tiles[g]._locations[k].y!=this._tiles[g]._locations[k].destinationy)f=!0;this._tiles[g]._locations[k].x=this._easing.ease(h,this._tiles[g]._locations[k].startx,this._tiles[g]._locations[k].destinationx-this._tiles[g]._locations[k].startx,i),this._tiles[g]._locations[k].y=this._easing.ease(h,this._tiles[g]._locations[k].starty,this._tiles[g]._locations[k].destinationy-this._tiles[g]._locations[k].starty,i);if(this._tiles[g].width!=this._tiles[g].destinationWidth||this._tiles[g].height!=this._tiles[g].destinationHeight)f=!0;this._tiles[g].width=this._easing.ease(h,this._tiles[g].startwidth,this._tiles[g].destinationwidth-this._tiles[g].startwidth,i),this._tiles[g].height=this._easing.ease(h,this._tiles[g].startheight,this._tiles[g].destinationheight-this._tiles[g].startheight,i)}else{this._tiles[g]._locations[k].x=this._tiles[g]._locations[k].destinationx,this._tiles[g]._locations[k].y=this._tiles[g]._locations[k].destinationy,this._tiles[g].width=this._tiles[g].destinationwidth,this._tiles[g].height=this._tiles[g].destinationheight;if(!isNaN(h)&&!isNaN(i)&&a){var j="";for(t=0;t<this._tiles.length;t++)if(this._tiles[t].facetItem.Id==b){j=this._tiles[t];break}b&&j&&$.publish("/PivotViewer/Views/Canvas/Click",[{x:j._locations[j.selectedLoc].destinationx,y:j._locations[j.selectedLoc].destinationy}]),a=!1,b=0}}this._tiles[g]._locations[k].destinationx+this._tiles
[g].destinationwidth<0||this._tiles[g]._locations[k].destinationx>d.canvas.width||this._tiles[g]._locations[k].destinationy+this._tiles[g].destinationheight<0||this._tiles[g]._locations[k].destinationy>d.canvas.height?this._tiles[g].destinationVisible=!1:this._tiles[g].destinationVisible=!0}}this._isZooming!=f&&(this._isZooming=f,$.publish("/PivotViewer/ImageController/Zoom",[this._isZooming])),d.clearRect(0,0,d.canvas.width,d.canvas.height);for(var g=0;g<this._tiles.length;g++)for(var k=0;k<this._tiles[g]._locations.length;k++)this._tiles[g]._locations[k].x+this._tiles[g].width>0&&this._tiles[g]._locations[k].x<d.canvas.width&&this._tiles[g]._locations[k].y+this._tiles[g].height>0&&this._tiles[g]._locations[k].y<d.canvas.height&&(e?this._tiles[g].DrawEmpty(k):this._tiles[g].Draw(k));if(!!this._breaks){this._started=!1;return}requestAnimFrame(function(){c.AnimateTiles(a,b)})},BeginAnimation:function(a,b){!this._started&&this._tiles.length>0&&(this._breaks=!1,this.AnimateTiles(a,b))},StopAnimation:function(){this._breaks=!0},SetLinearEasingBoth:function(){this._easing=new Easing.Easer({type:"linear",side:"both"})},SetCircularEasingBoth:function(){this._easing=new Easing.Easer({type:"circular",side:"both"})},SetQuarticEasingOut:function(){this._easing=new Easing.Easer({type:"quartic",side:"out"})},GetMaxTileRatio:function(){return this._imageController.MaxRatio},DrawHelpers:function(a){this._helpers=a},DrawHelperText:function(a){this._helperText=a}}),PivotViewer.Views.Tile=Object.subClass({init:function(a){if(!(this instanceof PivotViewer.Views.Tile))return new PivotViewer.Views.Tile(a);this._controller=a,this._imageLoaded=!1,this._selected=!1,this._level=0,this._images=null,this._locations=[]},IsSelected:function(){return this._selected},Draw:function(a){if(this.destinationVisible){var b=this.width>this.height?this.width:this.height,c=Math.ceil(Math.log(b)/Math.log(2));if(c==Infinity||c==-Infinity)c=0;this._level=c,this._images=this._controller.GetImagesAtLevel(this.facetItem.Img,this._level)}if(this._images!=null){if(typeof this._images=="function")this._images(this.facetItem,this.context,this._locations[a].x+4,this._locations[a].y+4,this.width-8,this.height-8);else if(this._images.length>0&&this._images[0]instanceof Image){var d=this._controller.GetHeight(this.facetItem.Img),e=this.height-8,f=Math.ceil(this._controller.GetWidthForImage(this.facetItem.Img,e));blankWidth=this.width-8-f;for(var g=0;g<this._images.length;g++){var h=this._images[g].src,i=this._controller._tileSize,j=h.match(/[0-9]+_[0-9]+/g),k=parseInt(j[j.length-1].substring(0,j[j.length-1].indexOf("_"))),l=parseInt(j[j.length-1].substring(j[j.length-1].indexOf("_")+1));j=h.match(/_files\/[0-9]+\//g);var m=parseInt(j[0].substring(7,j[0].length-1)),n=Math.ceil(d/Math.pow(2,this._controller.GetMaxLevel(this.facetItem.Img)-m)),o=e/n;overlap=this._controller.GetOverlap(this.facetItem.Img);var p=Math.floor(blankWidth/2)+4+k*Math.floor((i-overlap)*o),q=4+Math.floor(l*(i-overlap)*o),r=Math.ceil(this._images[g].height*o),s=Math.ceil(this._images[g].width*o);this.context.drawImage(this._images[g],p+this._locations[a].x,q+this._locations[a].y,s,r)}if(this._selected){this.context.beginPath();var p=Math.floor(blankWidth/2)+4,q=4;this.context.rect(p+this._locations[this.selectedLoc].x,q+this._locations[this.selectedLoc].y,f,e),this.context.lineWidth=4,this.context.strokeStyle="#92C4E1",this.context.stroke()}}}else this.DrawEmpty(a)},Contains:function(a,b){var c=!1,d=-1;for(i=0;i<this._locations.length;i++)c=this._locations[i].x<=a&&this._locations[i].x+this.width>=a&&this._locations[i].y<=b&&this._locations[i].y+this.height>=b,c&&(d=i);return d},DrawEmpty:function(a){this._controller.DrawLevel==undefined?(this.context.beginPath(),this.context.fillStyle="#D7DDDD",this.context.fillRect(this._locations[a].x+4,this._locations[a].y+4,this.width-8,this.height-8),this.context.rect(this._locations[a].x+4,this._locations[a].y+4,this.width-8,this.height-8),this.context.lineWidth=1,this.context.strokeStyle="white",this.context.stroke()):this._controller.DrawLevel(this.facetItem,this.context,this._locations[a].x+4,this._locations[a].y+4,this.width-8,this.height-8)},CollectionRoot:"",now:null,end:null,width:0,height:0,origwidth:0,origheight:0,ratio:1,startwidth:0,startheight:0,destinationwidth:0,destinationheight:0,destinationVisible:!0,context:null,facetItem:null,firstFilterItemDone:!1,selectedLoc:0,Selected:function(a){this._selected=a}}),PivotViewer.Views.TileLocation=Object.subClass({init:function(){},x:0,y:0,startx:0,starty:0,destinationx:0,destinationy:0}),PivotViewer.Views.DeepZoomImageController=PivotViewer.Views.IImageController.subClass({init:function(){this._items=[],this._collageItems=[],this._baseUrl="",this._collageMaxLevel=0,this._tileSize=256,this._format="",this._ratio=1,this.MaxRatio=1,this._zooming=!1;var a=this;$.subscribe("/PivotViewer/ImageController/Zoom",function(b){a._zooming=b})},Setup:function(a){this._baseUrl=a.substring(0,a.lastIndexOf("/")),this._collageUrl=a.substring(a.lastIndexOf("/")+1).replace(".xml","_files");var b=this;$.ajax({type:"GET",url:a,dataType:"xml",success:function(a){var c=$(a).find("Collection");b._tileSize=$(c).attr("TileSize"),b._format=$(c).attr("Format"),b._collageMaxLevel=$(c).attr("MaxLevel");var d=$(a).find("I");if(d.length==0){$(".pv-loading").remove();var e="";e+="No items in the DeepZoom Collection<br><br>",e=e+"URL        : "+this.url+"<br>",e+="<br>Pivot Viewer cannot continue until this problem is resolved<br>",$(".pv-wrapper").append('<div id="pv-dzloading-error" class="pv-modal-dialog"><div><a href="#pv-modal-dialog-close" title="Close" class="pv-modal-dialog-close">X</a><h2>HTML5 PivotViewer</h2><p>'+e+"</p></div></div>");var f=setTimeout(function(){window.open("#pv-dzloading-error","_self")},1e3);return}var g=$(d[0]).find("Size");if(g.length>0){b.MaxWidth=parseInt(g.attr("Width")),b.Height=parseInt(g.attr("Height")),b.MaxRatio=b.Height/b.MaxWidth;for(i=0;i<d.length;i++){itemSize=$(d[i]).find("Size");var h=parseInt(itemSize.attr("Width")),j=parseInt(itemSize.attr("Height")),k=h>j?h:j,l=Math.ceil(Math.log(k)/Math.log(2));b._ratio=j/h;var m=$(d[i]).attr("Source"),n=$(d[i]).attr("Id"),o=$(d[i]).attr("N"),p=m.substring(m.lastIndexOf("/")+1).replace(/\.xml/gi,"").replace(/\.dzi/gi,""),q=m.substring(0,m.lastIndexOf("/"));q.length>0&&(q+="/"),h>b.MaxWidth&&(b.MaxWidth=h),b._ratio<b.MaxRatio&&(b.MaxRatio=b._ratio),b._items.push(new PivotViewer.Views.DeepZoomItem(n,p,o,q,b._ratio,h,j,l,b._baseUrl,m))}}$.publish("/PivotViewer/ImageController/Collection/Loaded",null)},error:function(a,b,c){$(".pv-loading").remove();var d="";d+="Error loading from DeepZoom Cache<br><br>",d=d+"URL        : "+this.url+"<br>",d=d+"Status : "+a.status+" "+c+"<br>",d=d+"Details    : "+a.responseText+"<br>",d+="<br>Pivot Viewer cannot continue until this problem is resolved<br>",$(".pv-wrapper").append('<div id="pv-dzloading-error" class="pv-modal-dialog"><div><a href="#pv-modal-dialog-close" title="Close" class="pv-modal-dialog-close">X</a><h2>HTML5 PivotViewer</h2><p>'+d+"</p></div></div>");var e=setTimeout(function(){window.open("#pv-dzloading-error","_self")},1e3)}})},GetImagesAtLevel:function(a,b){b=b<=0?6:b;for(var c=0;c<this._items.length;c++)if(this._items[c].ItemId==a){b=b>this._items[c].MaxLevel?this._items[c].MaxLevel:b;var d=this._items[c].DZN.toString(2),e="",f="";for(var g=0;g<d.length;g++)g%2==0?e+=d[g]:f+=d[g];dzCol=parseInt(e,2),dzRow=parseInt(f,2);if(this._items[c].Levels!=undefined&&this._items[c].Levels.length!=0||!!this._zooming){if(this._items[c].Levels.length<b&&!this._zooming){var h=this.GetImageList(c,this._baseUrl+"/"+this._items[c].BasePath+this._items[c].DZId+"_files/"+b+"/",b),i=new PivotViewer.Views.LoadImageSetHelper;i.LoadImages(h),this._items[c].Levels.splice(b,0,i)}for(var j=b;j>-1;j--){if(this._items[c].Levels[j]!=undefined&&this._items[c].Levels[j].IsLoaded())return this._items[c].Levels[j].GetImages();if(j==b&&this._items[c].Levels[j]==undefined&&!this._zooming){var h=this.GetImageList(c,this._baseUrl+"/"+this._items[c].BasePath+this._items[c].DZId+"_files/"+j+"/",j),i=new PivotViewer.Views.LoadImageSetHelper;i.LoadImages(h),this._items[c].Levels.splice(j,0,i)}}return null}var h=this.GetImageList(c,this._baseUrl+"/"+this._items[c].BasePath+this._items[c].DZId+"_files/6/",6),i=new PivotViewer.Views.LoadImageSetHelper;return i.LoadImages(h),this._items[c].Levels.push(i),null}return null},GetImageList:function(a,b,c){var d=[],e=this._tileSize,f=this._format,g=this._items[a].Ratio,h=this._items[a].Height,i=this._items[a].MaxLevel,j=Math.ceil(h/g/Math.pow(2,i-c)),k=Math.ceil(h/Math.pow(2,i-c)),l=Math.ceil(j/e),m=Math.ceil(k/e);for(var n=0;n<l;n++)for(var o=0;o<m;o++)d.push(b+n+"_"+o+"."+f);return d},GetWidthForImage:function(a,b){for(var c=0;c<this._items.length;c++)if(this._items[c].ItemId==a)return Math.floor(b/this._items[c].Ratio)},GetDzi:function(a){for(var b=0;b<this._items.length;b++)if(this._items[b].ItemId==a)return dziName=this._baseUrl+"/"+this._items[b].BasePath+this._items[b].DZId+".dzi",dziName},GetMaxLevel:function(a){for(var b=0;b<this._items.length;b++)if(this._items[b].ItemId==a)return this._items[b].MaxLevel},GetWidth:function(a){for(var b=0;b<this._items.length;b++)if(this._items[b].ItemId==a)return this._items[b].Width},GetHeight:function(a){for(var b=0;b<this._items.length;b++)if(this._items[b].ItemId==a)return this._items[b].Height},GetOverlap:function(a){for(var b=0;b<this._items.length;b++)if(this._items[b].ItemId==a)return this._items[b].Overlap},GetRatio:function(a){for(var b=0;b<this._items.length;b++)if(this._items[b].ItemId==a)return this._items[b].Ratio}}),PivotViewer.Views.DeepZoomItem=Object.subClass({init:function(a,b,c,d,e,f,g,h,i,j){this.ItemId=a,this.DZId=b,this.DZN=parseInt(c),this.BasePath=d,this.Levels=[],this.Ratio=e,this.Width=f,this.Height=g,this.MaxLevel=h;var k=this;$.ajax({type:"GET",url:i+"/"+j,dataType:"xml",success:function(a){var b=$(a).find("Image");if(b.length==0)return;var c=$(b[0]);k.Overlap=c.attr("Overlap")},complete:function(a,b){},error:function(a,b,c){k.Overlap=0}})}}),function(a){var b=[],c=[],d=[],e=[],f=[],g=[],h=[],k=0,l,m,n=[],o=[],p="",q=0,r="",s="",u="",v="",w="",x="",y=!1,z="",A="",B,C=null,D=null,E={View:null,Facet:null,Filters:[]},F=null,G={},H=!1,I,J=new PivotViewer.Models.Collection,K={init:function(a){F=this,F.addClass("pv-wrapper"),InitPreloader();if(a.Loader==undefined)throw"Collection loader is undefined.";if(!(a.Loader instanceof PivotViewer.Models.Loaders.ICollectionLoader))throw"Collection loader does not inherit from PivotViewer.Models.Loaders.ICollectionLoader.";a.Loader.LoadCollection(J);if(a.ImageController==undefined)B=new PivotViewer.Views.DeepZoomImageController;else{if(!a.ImageController instanceof PivotViewer.Views.IImageController)throw"Image Controller does not inherit from PivotViewer.Views.IImageController.";B=a.ImageController}a.GoogleAPIKey!=undefined&&(I=a.GoogleAPIKey);if(a.ViewerState!=undefined){var b=a.ViewerState.split("&");for(var c=0,d=b.length;c<d;c++){var e=b[c].split("=");if(e.length==2)if(e[0]=="$view$")E.View=parseInt(e[1])-1;else if(e[0]=="$facet0$")E.Facet=PivotViewer.Utils.EscapeItemId(e[1]);else if(e[0]=="$selection$")E.Selection=PivotViewer.Utils.EscapeItemId(e[1]);else if(e[0]=="$tableFacet$")E.TableFacet=PivotViewer.Utils.EscapeItemId(e[1]);else if(e[0]=="$mapCentreX$")E.MapCentreX=e[1];else if(e[0]=="$mapCentreY$")E.MapCentreY=e[1];else if(e[0]=="$mapType$")E.MapType=PivotViewer.Utils.EscapeItemId(e[1]);else if(e[0]=="$mapZoom$")E.MapZoom=PivotViewer.Utils.EscapeItemId(e[1]);else{var f={Facet:e[0],Predicates:[]},g=e[1].split("_");for(var h=0,i=g.length;h<i;h++)if(g[h].indexOf(".")>0){var j=g[h].substring(0,g[h].indexOf(".")),k=g[h].substring(g[h].indexOf(".")+1);f.Predicates.push({Operator:j,Value:k})}E.Filters.push(f)}}}},show:function(){Debug.Log("Show")},hide:function(){Debug.Log("Hide")}};InitPreloader=function(){F.append("<div class='pv-loading'><img src='images/loading.gif' alt='Loading' /><span>Loading...</span></div>"),a(".pv-loading").css("top",a(".pv-wrapper").height()/2-33+"px"),a(".pv-loading").css("left",a(".pv-wrapper").width()/2-43+"px")},InitTileCollection=function(){InitUI();var b=J.ImageBase;b.indexOf("http",0)>=0||b.indexOf("www.",0)>=0||(b=J.CXMLBase.substring(0,J.CXMLBase.lastIndexOf("/")+1)+b);var c=a(".pv-viewarea-canvas")[0].getContext("2d");m=new PivotViewer.Views.TileController(B),n=m.initTiles(J.Items,b,c),B.Setup(b.replace("\\","/"))},InitPivotViewer=function(){CreateFacetList(),CreateViews(),AttachEventHandlers(),a(".pv-loading").remove(),ApplyViewerState(),r=GetItem(E.Selection),s=E.TableFacet,u=E.MapCentreX,v=E.MapCentreY,w=E.MapType,x=E.MapZoom;var c=a(".pv-toolbarpanel").innerWidth()-(a(".pv-toolbarpanel-brandimage").outerWidth(!0)+25+a(".pv-toolbarpanel-name").outerWidth(!0)+a(".pv-toolbarpanel-zoomcontrols").outerWidth(!0)+124+a(".pv-toolbarpanel-sortcontrols").outerWidth(!0));a(".pv-toolbarpanel-facetbreadcrumb").css("width",c+"px");if(E.View!=null){if(E.View!=0||E.View!=1)SelectView(0,!0),y=!1;SelectView(E.View,!0)}else SelectView(0,!0);var d=r&&r.Id?r.Id:"";m.BeginAnimation(!0,d),k==3&&(r?(a.publish("/PivotViewer/Views/Item/Selected",[{id:r.Id,bkt:0}]),b[3].RedrawMarkers(r.Id)):(a.publish("/PivotViewer/Views/Item/Selected",[{id:"",bkt:0}]),b[3].RedrawMarkers("")))},InitUI=function(){var b="<div class='pv-toolbarpanel'>",c=J.BrandImage;c.length>0&&(b+="<img class='pv-toolbarpanel-brandimage' src='"+c+"'></img>"),b+="<span class='pv-toolbarpanel-name'>"+J.CollectionName+"</span>",b+="<div class='pv-toolbarpanel-facetbreadcrumb'></div>",b+="<div class='pv-toolbarpanel-zoomcontrols'><div class='pv-toolbarpanel-zoomslider'></div></div>",b+="<div class='pv-toolbarpanel-viewcontrols'></div>",b+="<div class='pv-toolbarpanel-sortcontrols'></div>",b+="</div>",F.append(b);var d=0;a(".pv-toolbarpanel-zoomslider").slider({max:100,change:function(b,c){var e=c.value-d;centreX=a(".pv-viewarea-canvas").width()/2,centreY=a(".pv-viewarea-canvas").height()/2,a.publish("/PivotViewer/Views/Canvas/Zoom",[{x:centreX,y:centreY,delta:.5*e}]),d=c.value}}),F.append("<div class='pv-mainpanel'></div>");var e=a(".pv-wrapper").height()-a(".pv-toolbarpanel").height()-6;a(".pv-mainpanel").css("height",e+"px"),a(".pv-mainpanel").append("<div class='pv-filterpanel'></div>"),a(".pv-mainpanel").append("<div class='pv-viewpanel'><canvas class='pv-viewarea-canvas' width='"+F.width()+"' height='"+e+"px'></canvas></div>"),a(".pv-mainpanel").append("<div class='pv-infopanel'></div>"),a(".pv-viewpanel").append("<div class='pv-tableview-table' id='pv-table'></div>"),a(".pv-viewpanel").append("<div class='pv-mapview-canvas' id='pv-map-canvas'></div>");var f=a(".pv-filterpanel");f.append("<div class='pv-filterpanel-clearall'>Clear All</div>").append("<input class='pv-filterpanel-search' type='text' placeholder='Search...' /><div class='pv-filterpanel-search-autocomplete'></div>").css("height",e-13+"px"),navigator.userAgent.match(/iPad/i)!=null?a(".pv-filterpanel-search").css("width",f.width()-10+"px"):a(".pv-filterpanel-search").css("width",f.width()-2+"px"),a(".pv-filterpanel-search-autocomplete").css("width",f.width()-8+"px").hide();var g=a(".pv-infopanel");g.css("left",a(".pv-mainpanel").offset().left+a(".pv-mainpanel").width()-205+"px").css("height",e-28+"px"),g.append("<div class='pv-infopanel-controls'></div>"),a(".pv-infopanel-controls").append("<div><div class='pv-infopanel-controls-navleft'></div><div class='pv-infopanel-controls-navleftdisabled'></div><div class='pv-infopanel-controls-navbar'></div><div class='pv-infopanel-controls-navright'></div><div class='pv-infopanel-controls-navrightdisabled'></div></div>"),a(".pv-infopanel-controls-navleftdisabled").hide(),a(".pv-infopanel-controls-navrightdisabled").hide(),g.append("<div class='pv-infopanel-heading'></div>"),g.append("<div class='pv-infopanel-details'></div>"),J.MaxRelatedLinks>0&&g.append("<div class='pv-infopanel-related'></div>"),J.CopyrightName!=""&&g.append("<div class='pv-infopanel-copyright'><a href=\""+J.CopyrightHref+'" target="_blank">'+J.CopyrightName+"</a></div>"),g.hide()},CreateFacetList=function(){for(var b=0;b<J.Items.length;b++){var g=J.Items[b];for(var h=0;h<J.FacetCategories.length;h++){var i=J.FacetCategories[h];if(i.IsFilterVisible){var j=!1;for(var k=0,l=g.Facets.length;k<l;k++){var m=g.Facets[k];if(m.Name==i.Name){for(var n=0;n<m.FacetValues.length;n++)if(i.Type==PivotViewer.Models.FacetType.String||i.Type==PivotViewer.Models.FacetType.Link){var o=!1,p="pv-facet-item-"+CleanName(m.Name)+"__"+CleanName(m.FacetValues[n].Value);for(var q=c.length-1;q>-1;q-=1)if(c[q].itemId==p){c[q].count+=1,o=!0;break}o||c.push({itemId:p,itemValue:m.FacetValues[n].Value,facet:m.Name,count:1})}else if(i.Type==PivotViewer.Models.FacetType.Number){var r=!1;for(var q=0;q<d.length;q++)if(d[q].Facet==g.Facets[k].Name){d[q].Values.push(m.FacetValues[n].Value),r=!0;break}r||d.push({Facet:m.Name,Values:[m.FacetValues[n].Value]})}else if(i.Type==PivotViewer.Models.FacetType.DateTime){var s=!1,p="pv-facet-item-"+CleanName(m.Name)+"__"+CleanName(m.FacetValues[n].Value);for(var q=0;q<e.length;q++)if(e[q].itemId==p){e[q].count+=1,s=!0;break}s||e.push({itemId:p,itemValue:m.FacetValues[n].Value,facet:m.Name,count:1})}j=!0}}if(!j){var o=!1,p="pv-facet-item-"+CleanName(i.Name)+"__"+CleanName("(no info)");for(var q=c.length-1;q>-1;q-=1)if(c[q].itemId==p){c[q].count+=1,o=!0;break}o||c.push({itemId:p,itemValue:"(no info)",facet:i.Name,count:1})}}if(i.IsWordWheelVisible)for(var k=0,l=g.Facets.length;k<l;k++){var m=g.Facets[k];if(m.Name==i.Name)for(var n=0;n<m.FacetValues.length;n++)i.Type==PivotViewer.Models.FacetType.String&&f.push({Facet:m.Name,Value:m.FacetValues[n].Value})}}}var t=["<div class='pv-filterpanel-accordion'>"],u=[];for(var b=0;b<J.FacetCategories.length;b++)J.FacetCategories[b].IsFilterVisible&&(t[b+1]="<h3><a href='#' title="+J.FacetCategories[b].Name+">",t[b+1]+=J.FacetCategories[b].Name,t[b+1]+="</a><div class='pv-filterpanel-accordion-heading-clear' facetType='"+J.FacetCategories[b].Type+"'>&nbsp;</div></h3>",t[b+1]+="<div style='height:30%' id='pv-cat-"+CleanName(J.FacetCategories[b].Name)+"'>",J.FacetCategories[b].Type==PivotViewer.Models.FacetType.DateTime?t[b+1]+=CreateDateTimeFacet(J.FacetCategories[b].Name):J.FacetCategories[b].Type==PivotViewer.Models.FacetType.String||J.FacetCategories[b].Type==PivotViewer.Models.FacetType.Link?(J.FacetCategories[b].CustomSort!=undefined||J.FacetCategories[b].CustomSort!=null?t[b+1]+="<span class='pv-filterpanel-accordion-facet-sort' customSort='"+J.FacetCategories[b].CustomSort.Name+"'>Sort: "+J.FacetCategories[b].CustomSort.Name+"</span>":t[b+1]+="<span class='pv-filterpanel-accordion-facet-sort'>Sort: A-Z</span>",t[b+1]+=CreateStringFacet(J.FacetCategories[b].Name)):J.FacetCategories[b].Type==PivotViewer.Models.FacetType.Number&&(t[b+1]+="<div id='pv-filterpanel-category-numberitem-"+CleanName(J.FacetCategories[b].Name)+"'></div>"),t[b+1]+="</div>",u[b]="<option value='"+CleanName(J.FacetCategories[b].Name)+"' label='"+J.FacetCategories[b].Name+"'>"+J.FacetCategories[b].Name+"</option>");t[t.length]="</div>",a(".pv-filterpanel").append(t.join(""));for(var b=0;b<J.FacetCategories.length;b++)J.FacetCategories[b].IsFilterVisible&&SortFacetItems(J.FacetCategories[b].Name);a(".pv-filterpanel-accordion").css("height",a(".pv-filterpanel").height()-a(".pv-filterpanel-search").height()-75+"px"),a(".pv-filterpanel-accordion").accordion({}),a(".pv-toolbarpanel-sortcontrols").append('<select class="pv-toolbarpanel-sort">'+u.join("")+"</select>");for(var b=0;b<d.length;b++)CreateNumberFacet(CleanName(d[b].Facet),d[b].Values)},CreateDateTimeFacet=function(a){var b=["<ul class='pv-filterpanel-accordion-facet-list'>"];for(var c=0;c<e.length;c++)e[c].facet==a&&(b[c+1]="<li class='pv-filterpanel-accordion-facet-list-item'  id='"+e[c].itemId+"'>",b[c+1]+="<input itemvalue='"+CleanName(e[c].itemValue)+"' itemfacet='"+CleanName(a)+"' class='pv-facet-facetitem' type='checkbox' />",b[c+1]+="<span class='pv-facet-facetitem-label' title='"+e[c].itemValue+"'>"+e[c].itemValue+"</span>",b[c+1]+="<span class='pv-facet-facetitem-count'>0</span>",b[c+1]+="</li>");return b[b.length]="</ul>",b.join("")},CreateStringFacet=function(a){var b=["<ul class='pv-filterpanel-accordion-facet-list'>"];for(var d=0;d<c.length;d++)c[d].facet==a&&(b[d+1]="<li class='pv-filterpanel-accordion-facet-list-item'  id='"+c[d].itemId+"'>",b[d+1]+="<input itemvalue='"+CleanName(c[d].itemValue)+"' itemfacet='"+CleanName(a)+"' class='pv-facet-facetitem' type='checkbox' />",b[d+1]+="<span class='pv-facet-facetitem-label' title='"+c[d].itemValue+"'>"+c[d].itemValue+"</span>",b[d+1]+="<span class='pv-facet-facetitem-count'>0</span>",b[d+1]+="</li>");return b[b.length]="</ul>",b.join("")},CreateNumberFacet=function(b,c){var d=165,e=80,f=a("#pv-filterpanel-category-numberitem-"+PivotViewer.Utils.EscapeMetaChars(b));f.empty(),f.append("<span class='pv-filterpanel-numericslider-range-val'>&nbsp;</span>");var g="<svg class='pv-filterpanel-accordion-facet-chart' width='"+d+"' height='"+e+"'>",h=PivotViewer.Utils.Histogram(c),i=.5+d/h.BinCount|0,j=0;for(var k=0,l=h.Histogram.length;k<l;k++)j=j<h.Histogram[k].length?h.Histogram[k].length:j;for(var k=0,l=h.Histogram.length;k<l;k++){var m=.5+e/(j/h.Histogram[k].length)|0,n=.5+i*k|0;g+="<rect x='"+n+"' y='"+(e-m)+"' width='"+i+"' height='"+m+"'></rect>"}f.append(g+"</svg>");var o=a("#pv-filterpanel-category-numberitem-"+PivotViewer.Utils.EscapeMetaChars(b));o.append('</span><div id="pv-filterpanel-numericslider-'+b+'" class="pv-filterpanel-numericslider"></div><span class="pv-filterpanel-numericslider-range-min">'+h.Min+'</span><span class="pv-filterpanel-numericslider-range-max">'+h.Max+"</span>");var p=a("#pv-filterpanel-numericslider-"+PivotViewer.Utils.EscapeMetaChars(b));p.slider({range:!0,min:h.Min,max:h.Max,values:[h.Min,h.Max],slide:function(b,c){a(this).parent().find(".pv-filterpanel-numericslider-range-val").text(c.values[0]+" - "+c.values[1])},stop:function(b,c){var d=a(this),e=d.slider("option","min"),f=d.slider("option","max");c.values[0]>e||c.values[1]<f?d.parent().parent().prev().find(".pv-filterpanel-accordion-heading-clear").css("visibility","visible"):c.values[0]==e&&c.values[1]==f&&d.parent().parent().prev().find(".pv-filterpanel-accordion-heading-clear").css("visibility","hidden"),FilterCollection(!1)}})},CreateViews=function(){var c=a(".pv-viewpanel"),d=F.width(),e=a(".pv-mainpanel").height(),f=a(".pv-filterpanel").width()+18,g=4;b.push(new PivotViewer.Views.GridView),b.push(new PivotViewer.Views.GraphView),b.push(new PivotViewer.Views.TableView),b.push(new PivotViewer.Views.MapView);for(var h=0;h<b.length;h++)try{if(b[h]instanceof PivotViewer.Views.IPivotViewerView)b[h].Setup(d,e,f,g,m.GetMaxTileRatio()),c.append("<div class='pv-viewpanel-view' id='pv-viewpanel-view-"+h+"'>"+b[h].GetUI()+"</div>"),a(".pv-toolbarpanel-viewcontrols").append("<div class='pv-toolbarpanel-view' id='pv-toolbarpanel-view-"+h+"' title='"+b[h].GetViewName()+"'><img id='pv-viewpanel-view-"+h+"-image' src='"+b[h].GetButtonImage()+"' alt='"+b[h].GetViewName()+"' /></div>");else{var i="";i+="View does not inherit from PivotViewer.Views.IPivotViewerView<br>",a(".pv-wrapper").append('<div id="pv-view-error" class="pv-modal-dialog"><div><a href="#pv-modal-dialog-close" title="Close" class="pv-modal-dialog-close">X</a><h2>HTML5 PivotViewer</h2><p>'+i+"</p></div></div>"),window.open("#pv-view-error","_self")}}catch(j){alert(j.Message)}b[2].SetFacetCategories(J),b[3].SetFacetCategories(J)},global.setMapReady=function(){H=!0,SelectView(3,!0)},SelectView=function(c,d){if(c==3&&!H&&I){var e=document.createElement("script");e.type="text/javascript",e.src="https://maps.googleapis.com/maps/api/js?key="+I+"&sensor=false&callback=global.setMapReady",document.body.appendChild(e);return}if(c==3&&!I){var f="";f+='Viewing the data on Google maps requires an API key. This can be obtained from <a href="https://code.google.com/apis/console/?noredirect" target="_blank">here</a>',a(".pv-wrapper").append('<div id="pv-nomapkey-error" class="pv-modal-dialog"><div><a href="#pv-modal-dialog-close" title="Close" class="pv-modal-dialog-close">X</a><h2>HTML5 PivotViewer</h2><p>'+f+"</p></div></div>");var g=setTimeout(function(){window.open("#pv-nomapkey-error","_self")},1e3);return}for(var h=0;h<b.length;h++)c!=h&&(a("#pv-viewpanel-view-"+h+"-image").attr("src",b[h].GetButtonImage()),b[h].Deactivate(),b[h].init=!1);a("#pv-viewpanel-view-"+c+"-image").attr("src",b[c].GetButtonImageSelected()),k==1&&(c==2||c==3)&&(b[0].Activate(),b[0].init=d,k=0,FilterCollection(!0)),b[c].Activate(),b[c].init=d,k=c,c==1&&(a.publish("/PivotViewer/Views/Item/Selected",[{id:"",bkt:0}]),p=""),FilterCollection(!0)},SortFacetItems=function(b){var c=a("#pv-cat-"+PivotViewer.Utils.EscapeMetaChars(CleanName(b))+" ul"),d=c.prev().text().replace("Sort: ",""),e=c.children("li").get();if(d=="A-Z")e.sort(function(b,c){var d=a(b).children().first().attr("itemvalue"),e=a(c).children().first().attr("itemvalue");return d<e?1:d>e?-1:0});else if(d=="Quantity")e.sort(function(b,c){var d=parseInt(a(b).children(".pv-facet-facetitem-count").text()),e=parseInt(a(c).children(".pv-facet-facetitem-count").text());return d<e?-1:d>e?1:0});else{var f=J.GetFacetCategoryByName(b);if(f.CustomSort!=undefined){var g=[];for(var h=f.CustomSort.SortValues.length-1;h>-1;h-=1)for(var i=0;i<e.length;i++)f.CustomSort.SortValues[h]==a(e[i]).children(".pv-facet-facetitem-label").text()&&(g.push(e[i]),found=!0);e=g}}for(var h=0;h<e.length;h++)c.prepend(e[h])},ApplyViewerState=function(){E.Facet!=null&&(a(".pv-toolbarpanel-sort option[value="+CleanName(E.Facet)+"]").prop("selected","selected"),A=a(".pv-toolbarpanel-sort :selected").attr("label"),Debug.Log("current sort "+A));for(var b=0,c=E.Filters.length;b<c;b++)for(var d=0,e=E.Filters[b].Predicates.length;d<e;d++){var f=E.Filters[b].Predicates[d].Operator;if(f=="GT"||f=="GE"||f=="LT"||f=="LE"){var g=a("#pv-filterpanel-numericslider-"+CleanName(E.Filters[b].Facet)),h=parseFloat(E.Filters[b].Predicates[d].Value);switch(f){case"GT":g.slider("values",0,h+1);break;case"GE":g.slider("values",0,h);break;case"LT":g.slider("values",1,h-1);break;case"LE":g.slider("values",1,h)}g.parent().find(".pv-filterpanel-numericslider-range-val").text(g.slider("values",0)+" - "+g.slider("values",1)),g.parent().parent().prev().find(".pv-filterpanel-accordion-heading-clear").css("visibility","visible")}else f=="EQ"?SelectStringFacetItem(CleanName(E.Filters[b].Facet),CleanName(E.Filters[b].Predicates[d].Value)):f=="NT"&&SelectStringFacetItem(CleanName(E.Filters[b].Facet),"_no_info_")}},SelectStringFacetItem=function(b,c){var d=a('.pv-facet-facetitem[itemfacet="'+b+'"][itemvalue="'+c+'"]');d.prop("checked",!0),d.parent().parent().parent().prev().find(".pv-filterpanel-accordion-heading-clear").css("visibility","visible")},FilterCollection=function(c){var d=[],e=[],f=[],i=a(".pv-toolbarpanel-sort option:selected").attr("label");Debug.Log("sort "+i),c||(p="");var j=a(".pv-facet-facetitem:checked");a(".pv-filterpanel-clearall").css("visibility","hidden");var l=[];for(var q=0;q<j.length;q++){var t=G[a(j[q]).attr("itemfacet")],z=G[a(j[q]).attr("itemvalue")],A=!1;for(var B=0;B<l.length;B++)l[B].facet==t&&(l[B].facetValue.push(z),A=!0);A||l.push({facet:t,facetValue:[z]}),a.inArray(t,f)<0&&f.push(t)}var C=[];for(var q=0,D=J.FacetCategories.length;q<D;q++)if(J.FacetCategories[q].Type==PivotViewer.Models.FacetType.Number){var E=a("#pv-filterpanel-category-numberitem-"+CleanName(J.FacetCategories[q].Name)),F=a(E).find(".pv-filterpanel-numericslider");if(F.length>0){var H=F.slider("values"),I=F.slider("option","max"),K=F.slider("option","min");if(H[0]!=K||H[1]!=I){var t=J.FacetCategories[q].Name;C.push({facet:t,selectedMin:H[0],selectedMax:H[1],rangeMin:K,rangeMax:I}),a.inArray(t,f)<0&&f.push(t)}}}for(var q=0,D=J.Items.length;q<D;q++){var L=0;for(var M=0,N=l.length;M<N;M++)for(var O=0,P=l[M].facetValue.length;O<P;O++)if(l[M].facetValue[O]=="(no info)"){var Q=!1;for(var B=0,R=J.Items[q].Facets.length;B<R;B++)J.Items[q].Facets[B].Name==l[M].facet&&(Q=!0);Q==0&&L++}for(var B=0,R=J.Items[q].Facets.length;B<R;B++)for(var M=0,N=l.length;M<N;M++){var S=0;if(J.Items[q].Facets[B].Name==l[M].facet)for(var T=0,U=J.Items[q].Facets[B].FacetValues.length;T<U;T++)for(var O=0,P=l[M].facetValue.length;O<P;O++)J.Items[q].Facets[B].FacetValues[T].Value==l[M].facetValue[O]&&S++;S>0&&L++}if(L!=l.length)continue;for(var M=0,N=C.length;M<N;M++)if(C[M].selectedMin=="(no info)"){var Q=!1;for(var B=0,R=J.Items[q].Facets.length;B<R;B++)J.Items[q].Facets[B].Name==C[M].facet&&(Q=!0);Q==0&&L++}for(var B=0,R=J.Items[q].Facets.length;B<R;B++)for(var M=0,N=C.length;M<N;M++)if(J.Items[q].Facets[B].Name==C[M].facet)for(var T=0,U=J.Items[q].Facets[B].FacetValues.length;T<U;T++){var V=parseFloat(J.Items[q].Facets[B].FacetValues[T].Value);!isNaN(V)&&V>=C[M].selectedMin&&V<=C[M].selectedMax&&L++}if(L!=l.length+C.length)continue;d.push(J.Items[q].Id),l.length+C.length>0&&a(".pv-filterpanel-clearall").css("visibility","visible")}h=C,g=l,a(".pv-viewpanel-view").hide(),a("#pv-viewpanel-view-"+k).show(),FilterFacets(d,f),UpdateBreadcrumbNavigation(l,C),m.SetCircularEasingBoth(),y?(b[k].Filter(n,d,i,l,c,p),(k==2||k==3)&&!c&&b[0].Filter(n,d,i,l,!1,"")):(k==2?(b[k].SetSelectedFacet(s),b[k].Filter(n,d,i,l,c,r)):k==3?(b[k].SetMapInitCentreX(u),b[k].SetMapInitCentreY(v),b[k].SetMapInitType(w),b[k].SetMapInitZoom(x),b[k].applyBookmark=!0,b[k].Filter(n,d,i,l,c,r)):b[k].Filter(n,d,i,l,c,p),y=!0);var W=[];if(b[k].GetViewName()=="Graph View")W=b[k].GetSortedFilter();else for(var q=0;q<b[k].tiles.length;q++){var X=a.inArray(b[k].tiles[q].facetItem.Id,d);if(X>=0){var Y=new Object;Y.Id=b[k].tiles[q].facetItem.Id,Y.Bucket=0,W.push(Y)}}o=W,UpdateBookmark(),DeselectInfoPanel()},FilterFacets=function(b,f){if(b.length==J.Items.length){for(var g=e.length-1;g>-1;g-=1){var h=a("#"+PivotViewer.Utils.EscapeMetaChars(e[g].itemId));h.show(),h.find("span").last().text(e[g].count)}for(var g=c.length-1;g>-1;g-=1){var h=a("#"+PivotViewer.Utils.EscapeMetaChars(c[g].itemId));h.show(),h.find("span").last().text(c[g].count)}for(var g=0;g<d.length;g++)CreateNumberFacet(CleanName(d[g].Facet),d[g].Values);return}var i=[],j=[],k=[];for(var g=b.length-1;g>-1;g-=1){var h=J.GetItemById(b[g]);for(var l=0;l<J.FacetCategories.length;l++)if(J.FacetCategories[l].IsFilterVisible){var m=!1;for(var n=h.Facets.length-1;n>-1;n-=1)if(h.Facets[n].Name==J.FacetCategories[l].Name){if(a.inArray(h.Facets[n].Name,f)<0){var o=J.GetFacetCategoryByName(h.Facets[n].Name);if(o.IsFilterVisible)for(var p=h.Facets[n].FacetValues.length-1;p>-1;p-=1)if(o.Type==PivotViewer.Models.FacetType.String){var q={item:"#"+PivotViewer.Utils.EscapeMetaChars("pv-facet-item-"+CleanName(h.Facets[n].Name)+"__"+CleanName(h.Facets[n].FacetValues[p].Value)),count:1},r=!1;for(var s=i.length-1;s>-1;s-=1)if(i[s].item==q.item){i[s].count+=1,r=!0;break}r||i.push(q)}else if(o.Type==PivotViewer.Models.FacetType.Number){var t=!1;for(var s=0;s<j.length;s++)if(j[s].Facet==h.Facets[n].Name){j[s].Values.push(h.Facets[n].FacetValues[p].Value),t=!0;break}t||j.push({Facet:h.Facets[n].Name,Values:[h.Facets[n].FacetValues[p].Value]})}}m=!0}if(!m){var q={item:"#"+PivotViewer.Utils.EscapeMetaChars("pv-facet-item-"+CleanName(J.FacetCategories[l].Name)+"__"+CleanName("(no info)")),count:1},r=!1;for(var s=i.length-1;s>-1;s-=1)if(i[s].item==q.item){i[s].count+=1,r=!0;break}r||i.push(q)}}}for(var g=c.length-1;g>-1;g-=1)if(a.inArray(c[g].facet,f)<0){var r=!1;for(var n=i.length-1;n>-1;n-=1)if(i[n].item==c[g].itemId){r=!0;break}r||a("#"+PivotViewer.Utils.EscapeMetaChars(c[g].itemId)).hide()}else a("#"+PivotViewer.Utils.EscapeMetaChars(c[g].itemId)).find("span").last().text(c[g].count);for(var g=i.length-1;g>-1;g-=1){var u=a(i[g].item);if(u.length>0){u.show();var v=u.find("span").last();v.text(i[g].count)}}for(var g=0;g<j.length;g++)CreateNumberFacet(CleanName(j[g].Facet),j[g].Values)},UpdateBreadcrumbNavigation=function(b,c){var d=a(".pv-toolbarpanel-facetbreadcrumb");d.empty();if(b.length==0&&c.length==0)return;var e="|";for(var f=0,g=b.length;f<g;f++)e+="<span class='pv-toolbarpanel-facetbreadcrumb-facet'>"+b[f].facet+":</span><span class='pv-toolbarpanel-facetbreadcrumb-values'>",e+=b[f].facetValue.join(", "),e+="</span><span class='pv-toolbarpanel-facetbreadcrumb-separator'>&gt;</span>";for(var f=0,g=c.length;f<g;f++)e+="<span class='pv-toolbarpanel-facetbreadcrumb-facet'>"+c[f].facet+":</span><span class='pv-toolbarpanel-facetbreadcrumb-values'>",c[f].selectedMin==c[f].rangeMin?e+="Under "+c[f].selectedMax:c[f].selectedMax==c[f].rangeMax?e+="Over "+c[f].selectedMin:e+=c[f].selectedMin+" - "+
c[f].selectedMax,e+="</span><span class='pv-toolbarpanel-facetbreadcrumb-separator'>&gt;</span>";d.append(e)},DeselectInfoPanel=function(){a(".pv-infopanel").fadeOut(),a(".pv-infopanel-heading").empty(),a(".pv-infopanel-details").empty()},GetItemIds=function(a,b){var c=[];for(var d=0;d<J.Items.length;d++){var e=!1;for(var f=0;f<J.Items[d].Facets.length;f++)if(J.Items[d].Facets[f].Name==a){for(var g=0;g<J.Items[d].Facets[f].FacetValues.length;g++)b==J.Items[d].Facets[f].FacetValues[g].Value&&c.push(J.Items[d].Id);e=!0}!e&&b=="(no info)"&&c.push(J.Items[d].Id)}return c},GetItem=function(a){for(var b=0;b<J.Items.length;b++)if(J.Items[b].Id==a)return J.Items[b];return null},UpdateBookmark=function(){var a="#",c=k+1;a+="$view$="+c,A&&(a+="&$facet0$="+A),p&&(a+="&$selection$="+p.Id),k==2&&b[k].GetSelectedFacet()&&(a+="&$tableFacet$="+b[k].GetSelectedFacet()),k==3&&(b[k].GetMapCentreX()&&(a+="&$mapCentreX$="+b[k].GetMapCentreX()),b[k].GetMapCentreY()&&(a+="&$mapCentreY$="+b[k].GetMapCentreY()),b[k].GetMapType()&&(a+="&$mapType$="+b[k].GetMapType()),b[k].GetMapZoom()&&(a+="&$mapZoom$="+b[k].GetMapZoom()));var d=J.CollectionName;h.length+g.length>0&&(d+=" | ");if(g.length>0)for(i=0;i<g.length;i++){for(j=0;j<g[i].facetValue.length;j++)a+="&",a+=g[i].facet,a+="=EQ."+g[i].facetValue[j];d+=g[i].facet+": ",d+=g[i].facetValue.join(", "),i<g.length-1&&(d+=" > ")}if(h.length>0)for(i=0;i<h.length;i++)a+="&",a+=h[i].facet,d+=h[i].facet+": ",h[i].selectedMin==h[i].rangeMin?(a+="=LE."+h[i].selectedMax,d+="Under "+h[i].selectedMax):h[i].selectedMax==h[i].rangeMax?(a+="=GE."+h[i].selectedMin,d+="Over "+h[i].selectedMin):(a+="=GE."+h[i].selectedMin+"_LE."+h[i].selectedMax,d+="Between "+h[i].selectedMin+" and "+h[i].selectedMax),i<h.length-1&&(d+=" > ");typeof SetBookmark!=undefined&&typeof SetBookmark=="function"&&SetBookmark(J.CXMLBaseNoProxy,a,d)},CleanName=function(a){return name=a.replace(/[^\w]/gi,"_"),G[name]=a,name},a.subscribe("/PivotViewer/Models/Collection/Loaded",function(a){InitTileCollection()}),a.subscribe("/PivotViewer/ImageController/Collection/Loaded",function(b){InitPivotViewer();var c=a(".pv-filterpanel");c.append("<div class='pv-filterpanel-version'><a href=\"#pv-open-version\">About HTHL5 PivotViewer</a></div>"),c.append('<div id="pv-open-version" class="pv-modal-dialog"><div><a href="#pv-modal-dialog-close" title="Close" class="pv-modal-dialog-close">X</a><h2>HTML5 PivotViewer</h2><p>Version: '+a(PivotViewer)[0].Version+'</p><p>The sources are available on <a href="https://github.com/openlink/html5pivotviewer" target="_blank">github</a></p></div></div>')}),a.subscribe("/PivotViewer/Views/Item/Selected",function(c){if(c.id===undefined||c.id===null||c.id===""){DeselectInfoPanel(),p="",k==2&&b[k].Selected(p.Id),UpdateBookmark();return}var d=GetItem(c.id);if(d!=null){var e=!0;a(".pv-infopanel-heading").empty(),a(".pv-infopanel-heading").append('<a href="'+d.Href+'" target="_blank">'+d.Name+"</a></div>");var f=a(".pv-infopanel-details");f.empty(),d.Description!=undefined&&d.Description.length>0&&f.append("<div class='pv-infopanel-detail-description' style='height:100px;'>"+d.Description+"</div><div class='pv-infopanel-detail-description-more'>More</div>"),d.Id==o[0].Id&&d==o[o.length-1]?(a(".pv-infopanel-controls-navright").hide(),a(".pv-infopanel-controls-navrightdisabled").show(),a(".pv-infopanel-controls-navleft").hide(),a(".pv-infopanel-controls-navleftdisabled").show()):d.Id==o[0].Id?(a(".pv-infopanel-controls-navleft").hide(),a(".pv-infopanel-controls-navleftdisabled").show(),a(".pv-infopanel-controls-navright").show(),a(".pv-infopanel-controls-navrightdisabled").hide()):d.Id==o[o.length-1].Id?(a(".pv-infopanel-controls-navright").hide(),a(".pv-infopanel-controls-navrightdisabled").show(),a(".pv-infopanel-controls-navleft").show(),a(".pv-infopanel-controls-navleftdisabled").hide()):(a(".pv-infopanel-controls-navright").show(),a(".pv-infopanel-controls-navrightdisabled").hide(),a(".pv-infopanel-controls-navleft").show(),a(".pv-infopanel-controls-navleftdisabled").hide());var g=[],h=0;for(var i=0;i<d.Facets.length;i++){var j=!1,l=!1;for(var m=0;m<J.FacetCategories.length;m++)if(J.FacetCategories[m].Name==d.Facets[i].Name&&J.FacetCategories[m].IsMetaDataVisible){j=!0,l=J.FacetCategories[m].IsFilterVisible;break}if(j){g[h]="<div class='pv-infopanel-detail "+(e?"detail-dark":"detail-light")+"'><div class='pv-infopanel-detail-item detail-item-title' pv-detail-item-title='"+d.Facets[i].Name+"'>"+d.Facets[i].Name+"</div>";for(var m=0;m<d.Facets[i].FacetValues.length;m++)g[h]+="<div pv-detail-item-value='"+d.Facets[i].FacetValues[m].Value+"' class='pv-infopanel-detail-item detail-item-value"+(l?" detail-item-value-filter":"")+"'>",d.Facets[i].FacetValues[m].Href!=null?g[h]+="<a class='detail-item-link' href='"+d.Facets[i].FacetValues[m].Href+"'>"+d.Facets[i].FacetValues[m].Value+"</a>":g[h]+=d.Facets[i].FacetValues[m].Value,g[h]+="</div>";g[h]+="</div>",h++,e=!e}}if(d.Links.length>0){a(".pv-infopanel-related").empty();for(var n=0;n<d.Links.length;n++)a(".pv-infopanel-related").append("<a href='"+d.Links[n].Href+"'>"+d.Links[n].Name+"</a><br>")}f.append(g.join("")),a(".pv-infopanel").fadeIn(),f.css("height",a(".pv-infopanel").height()-(a(".pv-infopanel-controls").height()+a(".pv-infopanel-heading").height()+a(".pv-infopanel-copyright").height()+a(".pv-infopanel-related").height())-20+"px"),p=d,q=c.bkt,k==2&&b[k].Selected(p.Id),k==3&&b[k].RedrawMarkers(p.Id),UpdateBookmark();return}}),a.subscribe("/PivotViewer/Views/Item/Filtered",function(b){if(b==undefined||b==null)return;if(b.ClearFacetFilters==1)for(var c=0,d=J.FacetCategories.length;c<d;c++)if(J.FacetCategories[c].Name==b.Facet&&(J.FacetCategories[c].Type==PivotViewer.Models.FacetType.String||J.FacetCategories[c].Type==PivotViewer.Models.FacetType.DateTime)){var e=a('.pv-facet-facetitem[itemfacet="'+CleanName(b.Facet)+'"]');for(var f=0;f<e.length;f++)a(e[f]).prop("checked",!1)}for(var c=0,d=J.FacetCategories.length;c<d;c++){if(J.FacetCategories[c].Name==b.Facet&&(J.FacetCategories[c].Type==PivotViewer.Models.FacetType.String||J.FacetCategories[c].Type==PivotViewer.Models.FacetType.DateTime))if(b.Values)for(var f=0;f<b.Values.length;f++){var g=a(PivotViewer.Utils.EscapeMetaChars("#pv-facet-item-"+CleanName(b.Facet)+"__"+CleanName(b.Values[f]))+" input");g.prop("checked",!0),FacetItemClick(g[0])}else{var g=a(PivotViewer.Utils.EscapeMetaChars("#pv-facet-item-"+CleanName(b.Facet)+"__"+CleanName(b.Item))+" input");g.prop("checked",!0),FacetItemClick(g[0])}if(J.FacetCategories[c].Name==b.Facet&&J.FacetCategories[c].Type==PivotViewer.Models.FacetType.Number){var h=a("#pv-filterpanel-numericslider-"+PivotViewer.Utils.EscapeMetaChars(b.Facet));FacetSliderDrag(h,b.Item,b.MaxRange)}}}),a.subscribe("/PivotViewer/Views/Item/Updated",function(){UpdateBookmark()}),a.subscribe("/PivotViewer/Views/ChangeTo/Grid",function(b){var c="";for(t=0;t<n.length;t++)if(n[t].facetItem==b.Item){c=n[t];break}c&&a.publish("/PivotViewer/Views/Canvas/Click",[{x:c._locations[c.selectedLoc].destinationx+c.destinationwidth/2,y:c._locations[c.selectedLoc].destinationy+c.destinationheight/2}])}),a.subscribe("/PivotViewer/Views/Update/GridSelection",function(a){b[0].handleSelection(a.selectedItem,a.selectedTile)}),AttachEventHandlers=function(){a(".pv-toolbarpanel-view").on("click",function(a){var b=this.id.substring(this.id.lastIndexOf("-")+1,this.id.length);b!=null&&SelectView(parseInt(b),!1)}),a(".pv-toolbarpanel-sort").on("change",function(b){A=a(".pv-toolbarpanel-sort option:selected").attr("label"),Debug.Log("sort change _currentSort "+A),FilterCollection(!1)}),a(".pv-filterpanel-accordion-facet-sort").on("click",function(b){var c=a(this),d=c.text(),e=c.parent().prev().children("a").text(),f=c.attr("customSort");d=="Sort: A-Z"?a(this).text("Sort: Quantity"):d=="Sort: Quantity"&&f==undefined?a(this).text("Sort: A-Z"):d=="Sort: Quantity"?a(this).text("Sort: "+f):a(this).text("Sort: A-Z"),SortFacetItems(e)}),a(".pv-facet-facetitem").on("click",function(a){FacetItemClick(this)}),a(".pv-facet-facetitem-label").on("click",function(b){var c=a(this).prev(),d=a(this.parentElement.parentElement).find(":checked");c.prop("checked")==1&&d.length<=1?c.prop("checked",!1):c.prop("checked",!0);for(var e=d.length-1;e>-1;e-=1)d[e].getAttribute("itemvalue")!=c[0].getAttribute("itemvalue")&&(d[e].checked=!1);FacetItemClick(c[0])}),a(".pv-filterpanel-clearall").on("click",function(b){var c=a(".pv-facet-facetitem:checked");for(var d=0;d<c.length;d++)a(c[d]).prop("checked",!1);var e=a(".pv-filterpanel-numericslider");for(var d=0;d<e.length;d++){var f=a(e[d]),g=f.slider("option","min"),h=f.slider("option","max");f.slider("values",0,g),f.slider("values",1,h),f.prev().prev().html("&nbsp;")}a(".pv-filterpanel-search").val(""),a(".pv-filterpanel-accordion-heading-clear").css("visibility","hidden"),FilterCollection(!1)}),a(".pv-filterpanel-accordion-heading-clear").on("click",function(b){var c=this.attributes.facetType.value;if(c=="DateTime"){var d=a(this.parentElement).next().find(".pv-facet-facetitem:checked");for(var e=0;e<d.length;e++)a(d[e]).prop("checked",!1)}else if(c=="String"){var d=a(this.parentElement).next().find(".pv-facet-facetitem:checked");for(var e=0;e<d.length;e++)a(d[e]).prop("checked",!1)}else if(c=="Number"){var f=a(this.parentElement).next().find(".pv-filterpanel-numericslider"),g=f.slider("option","min"),h=f.slider("option","max");f.slider("values",0,g),f.slider("values",1,h),f.prev().prev().html("&nbsp;")}FilterCollection(!1),a(this).css("visibility","hidden")}),a(".ui-slider-range").on("mousedown",function(a){}),a(".pv-infopanel-details").on("click",".detail-item-value-filter",function(b){return a.publish("/PivotViewer/Views/Item/Filtered",[{Facet:a(this).parent().children().attr("pv-detail-item-title"),Item:this.getAttribute("pv-detail-item-value"),Values:null,ClearFacetFilters:!0}]),!1}),a(".pv-infopanel-details").on("click",".pv-infopanel-detail-description-more",function(b){var c=a(this),d=a(this).prev();c.text()=="More"?(d.css("height",""),a(this).text("Less")):(d.css("height","100px"),a(this).text("More"))}),a(".pv-infopanel-controls-navleft").on("click",function(c){for(var d=0;d<o.length;d++)if(o[d].Id==p.Id&&o[d].Bucket==q){d>=0&&a.publish("/PivotViewer/Views/Item/Selected",[{id:o[d-1].Id,bkt:o[d-1].Bucket}]);if(k==0||k==1)for(var e=0;e<n.length;e++)n[e].facetItem.Id==o[d-1].Id?(n[e].Selected(!0),selectedCol=b[k].GetSelectedCol(n[e],o[d-1].Bucket),selectedRow=b[k].GetSelectedRow(n[e],o[d-1].Bucket),b[k].CentreOnSelectedTile(selectedCol,selectedRow)):n[e].Selected(!1);break}}),a(".pv-infopanel-controls-navright").on("click",function(c){for(var d=0;d<o.length;d++)if(o[d].Id==p.Id&&o[d].Bucket==q){if(d<o.length){a.publish("/PivotViewer/Views/Item/Selected",[{id:o[d+1].Id,bkt:o[d+1].Bucket}]);if(k==0||k==1)for(var e=0;e<n.length;e++)n[e].facetItem.Id==o[d+1].Id?(n[e].Selected(!0),selectedCol=b[k].GetSelectedCol(n[e],o[d+1].Bucket),selectedRow=b[k].GetSelectedRow(n[e],o[d+1].Bucket),b[k].CentreOnSelectedTile(selectedCol,selectedRow)):n[e].Selected(!1)}break}}),a(".pv-filterpanel-search").on("keyup",function(b){var c=!1,d=[],e=a(".pv-filterpanel-search-autocomplete"),g=FilterCollection,h=SelectStringFacetItem;e.empty();if(b.keyCode==27){a(b.target).blur();return}for(var i=0,j=f.length;i<j;i++){var k=f[i].Value.toLowerCase();k.indexOf(b.target.value.toLowerCase())>=0&&a.inArray(k,d)==-1&&(d.push(k),e.append('<span facet="'+f[i].Facet+'">'+f[i].Value+"</span>"),b.keyCode==13&&(SelectStringFacetItem(CleanName(f[i].Facet),CleanName(f[i].Value)),c=!0))}a(".pv-filterpanel-search-autocomplete > span").on("mousedown",function(b){b.preventDefault(),a(".pv-filterpanel-search").val(b.target.textContent),a(".pv-filterpanel-search-autocomplete").hide(),h(CleanName(b.target.attributes[0].value),CleanName(b.target.textContent)),g()}),d.length>0&&e.show(),c&&FilterCollection(!1)}),a(".pv-filterpanel-search").on("blur",function(b){b.target.value="",a(".pv-filterpanel-search-autocomplete").hide()});var c=a(".pv-viewarea-canvas");c.on("mouseup",function(b){var c=a(this).offset(),d=b.clientX-c.left,e=b.clientY-c.top;(!D||D.x==0&&D.y==0)&&a.publish("/PivotViewer/Views/Canvas/Click",[{x:d,y:e}]),C=null,D=!1}),c.on("mouseout",function(a){C=null,D=!1}),c.on("mousedown",function(b){var c=a(this).offset(),d=b.clientX-c.left,e=b.clientY-c.top;C={x:d,y:e}}),c.on("mousemove",function(b){var c=a(this).offset(),d=b.clientX-c.left,e=b.clientY-c.top;C==null?a.publish("/PivotViewer/Views/Canvas/Hover",[{x:d,y:e}]):(D={x:d-C.x,y:e-C.y},C={x:d,y:e},a.publish("/PivotViewer/Views/Canvas/Drag",[D]))}),c.on("mousewheel",function(b,c){var d=a(this).offset(),e=b.clientX-d.left,f=b.clientY-d.top;m.SetQuarticEasingOut(),m.DrawHelpers([{x:e,y:f}]);var g=a(".pv-toolbarpanel-zoomslider").slider("option","value");c>0?g=g<5?5:g+5:c<0&&(g-=5),g=Math.max(0,Math.min(100,g)),a(".pv-toolbarpanel-zoomslider").slider("option","value",g)}),c.on("touchstart",function(b){var c=b.originalEvent,d=a(this).offset(),e=c.touches[0].pageX-d.left,f=c.touches[0].pageY-d.top;C={x:e,y:f}}),c.on("touchmove",function(b){try{var c=b.originalEvent;b.preventDefault();if(c.touches.length>1){b.preventDefault();var d=1e7,e=1e7,f=0,g=0,h=[];for(var i=0;i<c.touches.length;i++)h.push({x:c.touches[i].pageX,y:c.touches[i].pageY}),c.touches[i].pageX<d&&(d=c.touches[i].pageX),c.touches[i].pageX>f&&(f=c.touches[i].pageX),c.touches[i].pageY<e&&(e=c.touches[i].pageY),c.touches[i].pageY>g&&(g=c.touches[i].pageY);var j=(d+f)/2,k=(e+g)/2;m.SetLinearEasingBoth(),h.push({x:j,y:k}),m.DrawHelpers(h),m.DrawHelperText("Scale: "+c.scale),a.publish("/PivotViewer/Views/Canvas/Zoom",[{x:j,y:k,scale:c.scale}]);return}var l=a(this).offset(),n=c.touches[0].pageX-l.left,o=c.touches[0].pageY-l.top;D={x:n-C.x,y:o-C.y},C={x:n,y:o},a.publish("/PivotViewer/Views/Canvas/Drag",[D])}catch(p){Debug.Log(p.message)}}),c.on("touchend",function(b){var c=b.originalEvent;if(c.touches.length==1&&C==null){var d=a(this).offset(),e=c.touches[0].pageX-d.left,f=c.touches[0].pageY-d.top;(!D||D.x==0&&D.y==0)&&a.publish("/PivotViewer/Views/Canvas/Click",[{x:e,y:f}])}C=null,D=!1;return})},FacetItemClick=function(b){a(b).prop("checked")==1&&a(b.parentElement.parentElement.parentElement).prev().find(".pv-filterpanel-accordion-heading-clear").css("visibility","visible"),FilterCollection(!1)},FacetSliderDrag=function(b,c,d){var e=a(b),f=e.slider("option","min"),g=e.slider("option","max");c=="(no info)"&&(c=0),c>f||d<g?(e.parent().find(".pv-filterpanel-numericslider-range-val").text(c+" - "+d),e.slider("values",0,c),e.slider("values",1,d),e.parent().parent().prev().find(".pv-filterpanel-accordion-heading-clear").css("visibility","visible")):c==f&&d==g&&e.parent().parent().prev().find(".pv-filterpanel-accordion-heading-clear").css("visibility","hidden"),FilterCollection(!1)},a.fn.PivotViewer=function(b){if(K[b])return K[b].apply(this,Array.prototype.slice.call(arguments,1));if(typeof b=="object"||!b)return K.init.apply(this,arguments);a.error("Method "+b+" does not exist on jQuery.PivotViewer")}}(jQuery);